C****
C**** Simple S-wave NN potential with S-scattering length a = -20.0 fm
C**** + screened Coulomb
C****                 
C****     
	FUNCTION VC(L,R)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
        COMMON /RESCALE/ VSCALE(0:1),ZN1,ZN2,ZCORE,RCORE,RNUCL,RSCR
	VCEN=0D0
C *************************************************
C  ** FIRST get screened Coulomb potential:
        COUL = 1.44*ZN1*ZN2
        RAD = rnucl
        if(R.ge.RAD) VCOUL = COUL/R
        if(R.le.RAD) VCOUL = COUL* (3.-(R/RAD)**2)/(2.*RAD)
        if(RSCR.gt.0.01) VCOUL = VCOUL * EXP(-(R/RSCR)**2)
C *************************************************
	IF(L.EQ.0) THEN
C                           #######   nn s-wave
      	     VCEN=-31.D0*DDEXP(-(R/1.8D0)**2)
	ELSE IF(L.EQ.1) THEN
c   ##########   nn p-wave
           VCEN=0.0
	ELSE IF(L.EQ.2) THEN
c  ############## nn d-wave
c     	     VCEN=-31.D0*DDEXP(-(R/1.8D0)**2)
      	     VCEN=0.0
	ENDIF
	VC = VCEN + VCOUL
           RETURN
	ENTRY VLS(L,R)
           VLS=0.0
	    RETURN
	ENTRY VT(L,R)
           VT=0.0
	    RETURN
	ENTRY VLL(L,R)
	    VLL=0.
	    RETURN
	END
