C     ******************************************************************
C
C UC.......CENTRAL INTERACTION REID SOFT CORE, T=0 (NP)
C VC......CENTRAL INTERACTION REID SOFT CORE, T=1  (NN)
C UT.......TENSOR PART
C ULS......LS PART
C
**        We use the alternate version (to have a correct deuteron)
C
C     ******************************************************************
      FUNCTION UC (L,R)
      IMPLICIT REAL*8(A-H,O-Z)
	UC = 0.
	if(abs(R).lt.1e-5) return
      X=0.7*R
      E=EXP(-X)
      UC=E*(-10.463+E*(102.012+E*E*(-2915.0+7800.0*E*E)))/X
      RETURN
      END
C     ******************************************************************
      FUNCTION VC(L,R)
      IMPLICIT REAL*8(A-H,O-Z)
	VC = 0.
	if(abs(R).lt.1e-5) return
      X=0.7*R
      E=EXP(-X)
      VC=E*(-10.463-E**3*(1650.6-E**3*6484.2))/X
      RETURN
      END
C     ******************************************************************
      FUNCTION UT (L,R)
      IMPLICIT REAL*8(A-H,O-Z)
	UT = 0.
	if(abs(R).lt.1e-5) return
      X=0.7*R
      Y=1.0/X
      E=EXP(-X)
      UT=E*Y*(-10.463*(1.+3.*Y*(1.+Y)-3.*Y*(4.+Y)*E**3)+E**3*163.016)
      RETURN
      END
C     ******************************************************************
      FUNCTION ULS (L,R)
      IMPLICIT REAL*8(A-H,O-Z)
	ULS = 0.
	if(abs(R).lt.1e-5) return
      X=0.7*R
      E=EXP(-X)
      ULS=251.572D0*E**4/X
      RETURN
      END
C     ******************************************************************
      FUNCTION ULSC(L,R)
      IMPLICIT REAL*8(A-H,O-Z)
	ULSC = 0.
	if(abs(R).lt.1e-5) return
      X=0.7*R
      E=EXP(-X)
      ULSC=251.572D0*E**4/X
      RETURN
      END
	FUNCTION VLS(L,R)
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
	include 'actives.f'
		VLS = ULS(L,R)
		RETURN
	ENTRY VT(L,R)
		VT = UT(L,R)
		RETURN
	ENTRY VLL(L,R)
		if(INIT) ACTIVE(LNNLL)=.false.
		VLL = 0d0
		RETURN
	ENTRY ULL(L,R)
		if(INIT) ACTIVE(LNCLL)=.false.
		ULL = 0d0
		RETURN
	END
