C     ******************************************************************
C
C UC.......CENTRAL INTERACTION REID SOFT CORE, T=0 (NP)  L=0,2 only
C VC......CENTRAL INTERACTION REID SOFT CORE, T=1  (NN)  L=0 only
C UT.......TENSOR PART					 L=2 only
C ULS......LS PART					 L=2 only
C
**        We use the alternate version (to have a correct deuteron)
C
C     ******************************************************************
      FUNCTION UC (L,R)
      IMPLICIT REAL*8(A-H,O-Z)
      X=0.7*R
      E=EXP(-X)
      UC=E*(-10.463+E*(102.012+E*E*(-2915.0+7800.0*E*E)))/X
	if(L.ne.0.and.L.ne.2) UC=0.0
      RETURN
      END
C     ******************************************************************
      FUNCTION VC(L,R)
      IMPLICIT REAL*8(A-H,O-Z)
      X=0.7*R
      E=EXP(-X)
      VC=E*(-10.463-E**3*(1650.6-E**3*6484.2))/X
	if(L.ne.0) VC=0.0
      RETURN
      END
C     ******************************************************************
      FUNCTION UT (L,R)
      IMPLICIT REAL*8(A-H,O-Z)
      X=0.7*R
      Y=1.0/X
      E=EXP(-X)
      UT=E*Y*(-10.463*(1.+3.*Y*(1.+Y)-3.*Y*(4.+Y)*E**3)+E**3*163.016)
	if(L.ne.0.and.L.ne.2) UT=0.0
      RETURN
      END
C     ******************************************************************
      FUNCTION ULS (L,R)
      IMPLICIT REAL*8(A-H,O-Z)
      X=0.7*R
      E=EXP(-X)
      ULS=251.572D0*E**4/X
	if(L.ne.2) ULS=0.0
      RETURN
      END
C     ******************************************************************
      FUNCTION ULSC(L,R)
      IMPLICIT REAL*8(A-H,O-Z)
      X=0.7*R
      E=EXP(-X)
      ULSC=251.572D0*E**4/X
	if(L.ne.2) ULSC=0.0
      RETURN
      END
	FUNCTION VLS(L,R)
	include 'actives.f'
	IMPLICIT DOUBLE PRECISION(A-H,O-Z)
		if(INIT) ACTIVE(LNNLS)=.false.
		VLS = 0d0
		RETURN
	ENTRY VT(L,R)
		if(INIT) ACTIVE(LNNT)=.false.
		VT = 0d0
		RETURN
	ENTRY VLL(L,R)
		if(INIT) ACTIVE(LNNLL)=.false.
		VLL = 0d0
		RETURN
	ENTRY ULL(L,R)
		if(INIT) ACTIVE(LNCLL)=.false.
		ULL = 0d0
		RETURN
	END
