	program efaddy

C FADDEEV EQUATION MATRIX ELEMENTS OF 3-BODY nnC SYSTEMS WITH GIVEN J AND PTY
C VALUES IN THE  
C HYPERSPHERICAL&HYPERADIAL LAGUERRE BASIS
C (THE DEFINITION PTY=1 OR -1 IS USED)
C THE FADDEEV EQUATIONS ARE WRITTEN IN THE FORM

C H_0 PSI_2+V_2[(1-P(12))PSI2+PSI3]=E PSI2
C H_0 PSI_3+V_3[(1-P(12))PSI2+PSI3]=E PSI3

C WHERE V_3=V(NN); V_2=V(NC)

C THE DEFINITIONS OF THE COORDINATES:
C X_3=2^(-1/2)(R_2-R_1) Y_3=[2A_C/(A_C+2)]^(1/2)[R_3-(1/2)(R_1+R_2)]

C X_2=(A_C/(A_C+1))^(1/2)(R_3-R_1) 
C Y_2=((1+A_C)/(2+A_C))^(1/2)[R_2-(R_1+A_C R_3)/(A_C+1)]

C X_1=(A_C/(A_C+1))^(1/2)(R_3-R_2) 
C Y_1=((1+A_C)/(2+A_C))^(1/2)[R_1-(R_2+A_C R_3)/(A_C+1)]

C THESE COORDINATES ARE CONNECTED VIA THE PSEUDO ORTHOGONAL TRANSFORMATIONS:
C X_2=CPHI23*X_3+SPHI23*Y_3 Y_2=SPHI23*X_3-CPHI23*Y_3 (*)

C X_1=CPHI12*X_2+SPHI12*Y_2 Y_1=SPHI12*X_2-CPHI12*Y_2 (**)

C THE INVERSE TRANSFORMATIONS ARE PERFORMED WITH THE SAME MATRICES
C BOTH THE TRANSFORMATION (*) AND THE INVERSE TO IT, AND THE
C TRANSFORMATION INVERSE TO (**) ARE USED IN THE PROGRAM

      IMPLICIT real(KIND=selected_real_kind(12)) (A-H,O-Z)
      INCLUDE 'actives.f'
      parameter(MT=3, MBS=100)
	integer dp 
	parameter(dp = selected_real_kind(12))
      DIMENSION DLFAC(0:200),DL2FAC(0:200)
      real(kind=dp),allocatable:: XJ(:),WJ(:),  XL(:),WL(:), XLAG(:),
     & 		PJ(:,:,:,:), CTN(:,:),DTN(:,:),WN1(:,:)
      INTEGER,allocatable:: 
     &        KK3(:),LL13(:),LL23(:),LLTOT3(:),SSTOT3(:),
     &        KK2(:),LL12(:),LL22(:),LLTOT2(:),SSTOT2(:),
     &	      JNN3(:),II3(:),JNN2(:),II2(:),KKN(:),ICN(:),MP12(:)

c local (in OCC and EIGCC too: must match!):
      parameter(MAXEQ=7)

      	real(KIND=dp),allocatable::  WW(:,:,:),WM(:,:),RL(:,:),cf(:,:,:)
	real(kind=dp),allocatable:: VECSR(:,:),VALR(:)
	
	logical isonc,symm,MOMDIS,MONOPEX,callsusy,BLOCH
	INTEGER TT,PTY,SMAX,TTNC
      	INTEGER,allocatable:: K3MAX(:,:),K2MAX(:,:)
	COMMON/FACT/DLFAC,DL2FAC
	COMMON/ROT/CPHI,SPHI,TPHI,A(499,29),J1,J 
	COMMON/JLS/SQ6,SQ3,SQ5,SN
	COMMON /ISOSPIN/ZN,ZC,TT,TTNC
	COMMON /DEFORM/NTARG,KKKMAX,KTARG,DEF(2:5),BETA(2:5),
     X			VOLCON,CONS,QQ(2:5),MONOPEX
	COMMON /RESCALE/ VSCALE(0:1),ZN1,ZN2,ZCORE,RCORE,RN,RSCR,XLA,IJT
        COMMON /CORES/IC1,IC2,CALLDEF,LPOT
	LOGICAL CALLDEF
	CHARACTER*80 feval
	CHARACTER*80 fpot,fmel,fspec,pwfile,fmout,header,focc,pwinfile
	CHARACTER PSIGN(3),EOSIGN(3),EQN
	CHARACTER*2 PARITIES(10)
	DOUBLEPRECISION JV(MBS),KAPP,JTV(MBS), DEFH(2:5),ZCH(3),MSS(3),
     x		BEV(MBS)
        real(kind=dp),allocatable:: ASPL(:,:),YBS(:,:)
      	real(KIND=dp) KTARG,JTARG(MT),ETARG(MT),JTOT,JTOTS(10),JTMAX
        INTEGER ICV(MBS),NV(MBS),LV(MBS),PTARG(MT),KNF(MBS),KNL(MBS),
     X		KIND(MBS),DROPS(10),PRT(MBS),kmaxf(MT)
        integer,allocatable:: IO(:,:),IFO(:,:),isr(:)

      	LOGICAL PRIPOT,readpw,nooddnn,nooddcn,VOLCON,repeat,wfnrr,
     X		CONS,opw,POTPARTS,JPIDEP,YTORDER,havech,FESH,SPMEL
      	DATA PSIGN / '-',' ','+' /, EOSIGN / ' ','e','o' /

C DLFAC=LN(N!), DL2FAC=LN((2N+1)1); /ROT/ IS FOR CALCULATION OF THE HH 
C BRACKETS,
C SEE RRCOE; XJ AND WJ ARE QUADRATURE POINTS AND WEIGHTS FOR 
C GAUSS-JACOBI INTEGRATION. XL AND WL ARE THOSE FOR GAUSS-LAGUERRE 
C INTEGRATION; CC(L1,LD,I) ARE THE COEFFICIENTS (HH BRACKETS) REPRESENTING 
C THE BASIS HH 
C AS EXPANSIONS OVER "ROTATED" HH; RL ARE HYPERRADIAL FUNCTIONS STORED
C AT THE QUADRATURE POINTS; PJ(N,L1,LD,I) ARE SCALAR 
C JACOBI FACTORS ENTERING HH, STORED AT THE QUADRATURE POINTS. 
C (LD=(L1-L2+NN)/2 WHERE NN=0, OR 1 DEPENDING OF PTY SO THAT L1-L2+NN IS EVEN.)
C 
C KK3(I),LL13(I),LL23(I),LLTOT3(I) AND SSTOT3(I) ARE QUANTUM NUMBERS OF A
C PARTICULAR STATE IN THE EXPANSION OF THE PSI3 COMPONENT, AND SIMILARLY FOR 
C PSI2.
C VNNC,VNNLS,VNNT,VNNLL,VNCC AND VNCLS ARE ARRAYS OF RADIAL FACTORS OF VARIOUS 
C COMPONENTS OF THE NN AND NC INTERACTIONS WHILE
C WNNC,WNNLS,WNNT,WNNT1,WNNLL,WNCC AND WNCLS ARE ARRAYS OF MATRIX ELEMENTS 
C FROM THESE FACTORS BETWEEN THE CORRESPONDING "JACOBI" HH. WNNT AND WNNT1 
C CORRESPOND TO THE DELTA(L1)=0 AND DELTA(L1)=2 TRANSITIONS, RESPECTIVELY.     							        				  																  			
C ASSIGNING VALUES TO THE PARAMETERS
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
!	open(5,file='data')
	READ(5,99) HEADER
99	format(a80)
       	  READ(5,*) fpot
	mxfile=6
	mxfile=10
	if(mxfile.gt.6) then
       	  fmout=fpot(1:lnblnk(fpot))//'.mout'
          open (10,file =fmout,access = 'sequential',
     x         form='formatted',status = 'unknown')
	endif
           feval=fpot(1:lnblnk(fpot))//'.eval'
!           open (20,file =feval,access = 'sequential',
!     x         form='formatted',status = 'unknown')

c	H2M=20.735
c	H2M=20.748
	coulcn=1.4398523
	repeat = .false.
	opw = .false.
	CALL FACTORIAL(DLFAC,DL2FAC,200)
	SQ6=DSQRT(6.D0)
	SQ3=DSQRT(3.D0)
	SQ5=DSQRT(5.D0)
	NMAX=0
	NX=0
	NY=0
	NTARG=1
	JTARG(1)=0.0
	ETARG(1)=0.0
	PTARG(1)=1
	MONOPEX=.false.
	LPOT = 2

	READ(5,*) AC,ZC,RCORE
      	READ(5,*) NTARG,KTARG,(DEF(I),I=2,5)
	VOLCON = NTARG .lt.0
      	 if(VOLCON) then
		READ(5,*) (DEFH(I),I=2,5)
	 else
	  	do 94 i=2,5
94		DEFH(i) = DEF(i)
	 endif
c	if(RCORE.lt.1d-5) RCORE = 1.1*AC**(1./3.)
	NTARG = abs(NTARG)
	DO 95 KKKMAX=5,2,-1
95	IF(abs(DEF(KKKMAX)).gt.1e-10) go to 96
	KKKMAX=0
	JTMAX=0
96     	DO 97 ISC=1,NTARG
   	READ(5,*) JTARG(ISC),PTARG(ISC),ETARG(ISC)
97   	JTMAX = max(JTMAX,JTARG(ISC))
	  Q0CORE = 0.0
        if(JTMAX.lt.0.1.and.NTARG>1) MONOPEX=.true.
	if(JTMAX.gt.0.9) READ(5,*) Q0CORE
	  IF(NTARG.eq.0) NTARG = 1
	  KTARG = max(KTARG,JTARG(1)-int(JTARG(1)))
	  JNNMX = 100
	READ(5,*) AN,ZN,RN,SN,TT,(ZN2,RSCR,I1=1,min(1,nint(ZN)))
	ZN1=ZN
	ZCORE = ZC
	 ZCH(3)=ZC; ZCH(1)=ZN; ZCH(2)=ZN
	 MSS(3)=AC; MSS(1)=AN; MSS(2)=AN
	 PI=4d0*ATAN(1d0)
	 ZEFF=0
	 do i=1,3
	 do j=1,i-1
	 ZEFF = ZEFF+ ZCH(i)*ZCH(j)*sqrt(MSS(i)*MSS(j)/(MSS(i)+MSS(j)))
     X			* 16/(3*PI)
	 enddo
	 enddo
	READ(5,*) H2M
	if(H2M<0) then
	   BLOCH = .true.
	   READ(5,*)  RMATR,BCON
	   H2M = -H2M
	   endif
	READ(5,*) KMAX,LNCMAX,LNNMAX,SMAX,LLMAX,L2MX,EQN,
     x			(JNNMX,i=1,min(1,-L2MX))
	L2MX = abs(L2MX)
	MAXL = max(LNNMAX,LNCMAX,L2MX)
  	MAXL2 = MAXL*2
	allocate(K3MAX(0:MAXL+2,MT),K2MAX(0:MAXL+2,MT))
	MAXLR = min(MAXL,3)
	do 93 ic=1,MT
	do 93 i=0,MAXLR+1
93	K3MAX(i,IC)=0
	nooddcn = LNCMAX.lt.0
	nooddnn = LNNMAX.lt.0
	   DO 98 L1=0,MAXL+2
	   DO 98 IC=1,NTARG
	     K3MAX(L1,IC)=ABS(KMAX)
98	     K2MAX(L1,IC)=ABS(KMAX)
	   IF(KMAX.lt.-1) then
	     DO 982 IC=1,NTARG
	     READ(5,*) (K3MAX(L1,IC),L1=0,MAXLR),J,I1
	     K3MAX(MAXL+1,IC) = J
	     K3MAX(MAXL+2,IC) = I1
	     DO 981 L1=MAXLR+1,MAXL
981	     K3MAX(L1,IC)=K3MAX(MAXLR,IC)
	     DO 982 L1=0,MAXLR
982	     KMAX=max(abs(KMAX),J,abs(K3MAX(L1,IC)))
	   endif
	   IF(K3MAX(0,1).lt.0) then
	     DO 986 IC=1,NTARG
	     READ(5,*) (K2MAX(L1,IC),L1=0,MAXLR),J
	     K2MAX(MAXL+1,IC) = J
	     DO 985 L1=MAXLR+1,MAXL
985	     K2MAX(L1,IC)=K2MAX(MAXLR,IC)
	    K3MAX(0,1)=abs(K3MAX(0,1))
	     DO 986 L1=0,MAXLR
986	     KMAX=max(abs(KMAX),J,K2MAX(L1,IC))
	   endif
	   readpw = KMAX.eq.-1
	   IF(readpw) READ(5,*) pwinfile,thresh
	SMAX = min(SMAX,nint(2*SN))
        FESH = LGE(EQN,'a').AND.LLT(EQN,'z')
	RLOC = 0.0
	NDROP = 0
        if(FESH) then
	   READ(5,*) Kmaxf(1:NTARG),EFesh,RLOC,NDROP
	   EQN=CHAR(ICHAR(EQN)-ICHAR('a')+ICHAR('A'))
	   endif
	READ(5,*) RR,NLAG,NJAC,RINNER
	if(NDROP>=0) then
	 READ(5,*) NJT,(JTOTS(IJT),PARITIES(IJT),IJT=1,min(10,abs(NJT)))
	 DROPS(1:NJT) = NDROP
	else
	 READ(5,*) NJT,(JTOTS(IJT),PARITIES(IJT),DROPS(IJT),
     X			IJT=1,min(10,abs(NJT)))
	 do ijt=1,abs(NJT)
	 NDROP = max(NDROP,DROPS(ijt))
	 enddo
	endif
		JPIDEP = NJT.le.0
		NJT = min(10,abs(NJT))
	EMAX = 3.0
	DE = 0.1
	MEIGSI=1
	EPS2 = 0.1
	N3BLOCK=0
 	READ(5,*,ERR=256,END=256) NMAX,EMIN,(DE,EMAX,i=1,min(-NMAX,1)),
     x		(MEIGSI,MOMDIS,i=1,min(1,abs(NMAX)))
      	READ(5,*,ERR=256,END=256) DX,XMAX,DY,YMAX,RNODE,ITRBS,LBSMAX,
     x		KAPP,(EPS2,N3BLOCK,i=1,sign(1,int(-KAPP*1e4)))
c	LBSMAX = min(LNCMAX,LBSMAX)
 256	continue
	callsusy = DY<0
	if(callsusy) READ(5,*) DRHO,RHOMAX,KMAXSUSY
	MNMAX=abs(NMAX)
	MLAG = abs(NLAG)
	MJAC = abs(NJAC)
      allocate(XJ(MJAC),WJ(MJAC),  XL(MLAG),WL(MLAG), XLAG(0:MNMAX))
	MKMAX = KMAX
 	MNM=MKMAX/2+5
        ACTIVE(1:MAXACT)=.true.
        INIT = .true.
        LVACT = -1
c
C AC IS A CORE MASS NUMBER
C RR IS A LENGTH PARAMETER IN HYPERRADIAL FUNCTIONS 
C LNCMAX AND LNNMAX ARE MAXIMAL INTERACTION ORBITAL MOMENTA RETAINED IN
C THE CALCULATION. (FOR LNNMAX THIS MEANS THAT THE TRANSITIONS
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C THE NUMBERS OF QUADRATURE POINTS NLAG SHOULD BE HIGHER THEN 9

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C KMAX,NMAX,LNCMAX,LNNMAX,NLAG AND NJAC NUMBERS SHOULD BE IN ACCORDANCE
C WITH THE ABOVE-ANNOUNCED DIMENSIONS!
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

	do i=6,mxfile,4
	write(i,*) '  EFADDY program, version 1.75a'
	write(i,*)  '@ '
	write(i,1059)  fpot
 1059   format('  Run name: ',A80)
	WRITE(i,1060)  HEADER
 1060   format(' @ ',A80)
	write(i,*)
	write(i,1061) AC,ZC,RCORE
 1061 	format('  Core mass, charge, radius ',/,f11.4,2f8.3)
	  if(VOLCON) KKKMAX=5
        WRITE(i,1063) NTARG,KTARG,KKKMAX,(DEF(ik),ik=2,KKKMAX)
	  if(VOLCON) 
     X        WRITE(i,1063) NTARG,KTARG,KKKMAX,(DEFH(ik),ik=2,KKKMAX)
	do 1062 ik=2,KKKMAX
        BETA(ik) = DEF(ik)/RCORE
 1062   QQ(ik) = BETA(ik) * RCORE**ik * 3d0 * ZC / (3.14159*sqrt(5d0))
	  if(NTARG.ge.2) 
     X        WRITE(i,10631) (QQ(ik),ik=2,KKKMAX)
        DO ISA=1,NTARG
         WRITE(i,1064) ISA,JTARG(ISA),PSIGN(2+PTARG(ISA)),ETARG(ISA)
	ENDDO
		if(JTMAX.gt.0.9) WRITE(i,10642) Q0CORE
		if(MONOPEX) WRITE(i,10644) 
 1063 FORMAT(/5x,'  Number of core states=',I4, ', K =',F4.1,
     1           '   Max. multipole =',I2,:,/,
     2          10X, ' Delta2 .. Delta5 = ',4f8.4)
10631 FORMAT(10X, ' Intrinsic QQ2 .. QQ5 = ',4f8.4)
 1064 FORMAT(10X,'Core state #',I2,': ',F4.1,A1,' at',f7.3,' MeV')
10642   format(/'  Core intrinsic quadrupole moment/e^2 = ',f10.5)
10643   format(/'  Hyperradial 3-body effective charge  = ',f10.5)
	TTNC = 0
	if(NTARG.eq.1.and.abs(JTARG(1)-.5).lt.1e-5) 
     X			write(i,10645) TTNC
10644   format(/'  "Deformed" potentials used for MONOPOLE couplings')
10645   format(/'  For core = nucleon, assume valence-core isospin ',i2)

	write(i,1065) AN,ZN,RN,SN,TT
 1065 	format(/'  Valence particle mass, charge, radius, spin',
     X        ' & isospin',/,11x,f12.4,2f8.3,f6.1,I5)
	if(ZN.gt..5) write(i,10655) ZN1,ZN2,RSCR
10655 	format(/'  Separate valence charges =',2F4.1,
     X		', with Screening Radius =',f8.3,' fm.')
	if(ZEFF.gt.0.01) WRITE(i,10643) ZEFF
	write(i,1066) H2M,1./H2M,H2M/AN,AN/H2M
 1066	format(/'  hcross^2/2*unit-mass = ',f8.4,' =',f10.7,'^-1',/,
     X          '  hcross^2/2*valence   = ',f8.4,' =',f10.7,'^-1')
	if(BLOCH) WRITE(i,10665) RMATR,BCON
10665 	format(/'  Bloch operator at ',f8.3,' with B =',f8.4)
c	if(NMAX.ne.0) 
c    X	   NLAG = sign(max(9,min(abs(NLAG),MNMAX*2)),NLAG)
	WRITE(i,1067)RR,NLAG
 1067	format(/'  Hyperradial parameters =',f8.4,I5)
	WRITE(i,*)' Hyperangular points =',NJAC
	if(i.eq.6) then
	if(NMAX.ne.0) then
 		CALL QUALAG(XLAG(1),WL(1:MNMAX),MNMAX,5.D0)
 		CALL QUALAG(XL,WL,abs(NLAG),5.D0)
		do 308 N=1,abs(NLAG)
		U = XL(N)
308		WL(N)=WL(N)/(U**5d0 * exp(-U))		
	else
		do 309 N=1,abs(NLAG)
		wl(N)=RR
309		xl(N)=N
		xlag(0) = xl(abs(NLAG))
	endif
	  NPLAG = 0
	  NLLAG = 0
	  do 315 N=1,abs(NLAG)
	  if(RR*XL(N).le.RINNER+1e-3) NPLAG = N
	  if(RR*XL(N).le.RLOC+1e-3) NLLAG = N
315	  continue

	if(abs(RINNER).lt.1e-4) NPLAG=abs(NLAG)
	if(RINNER.lt.0.) NPLAG=0
	if(abs(RLOC).lt.1e-4) NLLAG=NPLAG
	if(RLOC.lt.0.) NLLAG=0

	  RLOC = 0
	  if(NLLAG.gt.0) RLOC = RR*XL(NLLAG)
	  RINNER = 0.0
	  if(NPLAG.gt.0) RINNER = RR*XL(NPLAG)
	  DY = abs(DY)
!	  YMAX = min(YMAX,max(0d0,RLOC-DY*0.5))
	  YMAX = min(YMAX,max(0d0,RLOC+DY*0.5))
	  if(YMAX.lt.0.) YMAX = max(0d0,RLOC-DY*0.5)
	endif

     	  WRITE(i,*)' Max radius of PP projectors (nonlocal or local) ='
     x			,real(RINNER),NPLAG
!     	  	if(FESH) 
      	  WRITE(i,*)' Min radius of local projectors =',real(RLOC),NLLAG
     x	  	,'    dropping ',NDROP,' levels '
      	  WRITE(i,*)

	if(callsusy) then
	  write(i,317) DRHO,RHOMAX,KMAXSUSY
317       format(' CALL SUSY for grid step',f8.4,', max ',f8.3,
     x      ' and KmaxSUSY = ',i4/)
	  endif
	if(readpw) then
	  WRITE(i,*) '  Read file ',pwinfile(1:lnblnk(pwinfile)),
     x               ' and select channels with weights >',real(thresh)
	else
	WRITE(i,*)'   Kmax =',Kmax,', LNCmax =',LNCmax,
     x			', LNNmax =',LNNmax
        WRITE(i,*)'   Smax =',Smax,', LLmax =',LLMAX,', L2max =',L2MX,
     x             ', Jnnmax =',JNNMX
	 if(nooddnn) WRITE(i,*) ' EVEN LNN only'
	 if(nooddcn) WRITE(i,*) ' EVEN LNC only'
	 LNCMAX = abs(LNCMAX)
	 LNNMAX = abs(LNNMAX)
	do 1069 IC=1,NTARG
1069	WRITE(i,*) '   Kmax for S,P,D,F ... DD,K/2 nn channels & core #'
     X			,IC,'=', (K3MAX(L1,IC),L1=0,MAXL+2)
	do 1070 IC=1,NTARG
1070	WRITE(i,*) '   Kmax for S,P,D,F .. DD nc+n channels & core ',
     X		'#',IC,'=', (K2MAX(L1,IC),L1=0,MAXL+1)
	endif
	WRITE(i,*)
	WRITE(i,*)' Equations to solve = ',EQN,'   (F=Faddeev, ',
     x		'T=T-Schrodinger:HH, N=OrthoNormal, Y) '
	if(FESH) then
	  write(i,*) ' Perform Feshbach reduction to Kmax =',
     x      Kmaxf(1:NTARG),' for energy =',real(EFesh)
	  endif
	write(i,1075)NJT,(JTOTS(IJT),PARITIES(IJT),DROPS(IJT),IJT=1,NJT)
 1075   format(/1X,I2,' Coupled channels J,pi,#blocked sets:',
     X			10(f5.1,a2,i3))
	if(DE<0) write(i,1076)JTOTS(1),PARITIES(1)
 1076   format(3X,' Only ground state for first set',f5.1,a1)
	MEIGS = MEIGSI
	if(NMAX.ne.0) then
	  WRITE(i,*) ' Nmax =',Nmax,', Emin =',real(EMIN),
     x	 	    ', MEIGS =',MEIGS,' with MOMDIS =',MOMDIS
!		MEIGS=max(MEIGS,1)
	  write(i,*)
	  WRITE(i,*) ' NLAG =',NLAG,' Recommend: >> NMAX =',NMAX
	 if(EMAX.gt.EMIN) then
     	  WRITE(i,1078) EMIN,EMAX,DE
 1078	  format(/'  Discretised response from',F7.3,
     *		' to ',F8.3,' in steps of ',F7.3,' MeV.'/)
	  endif
	else
          close (20,status='delete') 
	endif
c	if(NMAX.eq.0) KAPP = 1d-5
 	if(abs(KAPP).le.1d-3) KAPP = 1d-3
	WRITE(i,*) ' NJAC =',NJAC,' Recommend: >> KMAX/2 =',KMAX/2
        WRITE(i,*) '   (but much more, for repulsive-core interactions)'
	IF(YMAX.gt.0d0.and.XMAX.gt.0d0) 
     *	WRITE(i,1085) DX,XMAX,DY,YMAX,RNODE,ITRBS,LBSMAX,KAPP,EPS2,
     *        N3BLOCK
 1085 FORMAT(/' Bound states:  x in steps of ',F6.3,' to',F6.2,' fm,',/
     *     '  Spline functs y in steps of ',F6.3,' to',F6.2,' fm max.',
     */'  Counting nodes out to ',F6.2,' fm only, Trace level =',I2/,
     * '  Maximum L in b.s. =',I3,/
     * '  Non-linearity in spline spacing =',f8.4,' EPS2 =',f8.4,
     *    ', N3BLOCK=',i3/)
	enddo
	PRIPOT = NLAG.lt.0
	if(PRIPOT) then
 	  open(90,file=fpot(1:lnblnk(fpot))//'.dpots')
 	  open(91,file=fpot(1:lnblnk(fpot))//'.eadr')
 	  open(92,file=fpot(1:lnblnk(fpot))//'.ead')
	endif
	NLAG = abs(NLAG)
	wfnrr = .false.
	wfnrr = .true.
	POTPARTS = NJAC.lt.0
	NJAC = abs(NJAC)
	SPMEL = .false. !  KAPP.lt.0.
	KAPP = abs(KAPP)
c	KAPP = max(sqrt(abs(EMIN)/H2M),1d-5)
c	KAPP = 0.125
c	KAPP = 0.100
c	KAPP = 0.060

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
1400	NBS=0
	NTR=0
	NSRC=0
	VSCALE(0) = 1.0
	VSCALE(1) = 1.0
	IJT = 1
	CONS = .false.
 	T = UC(0,RNODE)
c	write(6,*) 'DEF(*) =',(real(DEF(ik)),ik=2,5)
c	write(6,*) 'VSCALE(*) =',(real(VSCALE(ik)),ik=0,1)
c	CALL POTDEF(-1,KKKMAX,RNC,VK,.true.)
cc	if(KKKMAX.gt.0) then
c    Sample output 
c	   DO RNC=0.5,5.,0.5
c	   CALL POTDEF(0,KKKMAX,RNC,VK(0),.true.)
c	 write(6,'(2HPT,f8.3,6f9.4)')RNC,(VK(J),J=0,KKKMAX,2),
c     x			UC(0,RNC),VSCALE
c	 enddo
cc	endif
cc	 write(6,*) 'END POTS'
	write(6,'(''  LPOT ='',i3)') LPOT
	EOCC = -20
   	if((YMAX.gt.0d0.or.NDROP.gt.0).and.XMAX.gt.0d0) then
       		NX = XMAX/DX+1.5
       		NY = YMAX/DY+0.5
		MX = NX
		NYMAX = NY
		NYP2 = NYMAX+2
     	allocate(ASPL(0:NYP2,0:NYMAX),YBS(MX,MBS))
C    FIND OCCUPIED CORE STATES
      	CALL OCC(YBS,MX,MBS,NV,LV,JV,ICV,JTV,KNF,KNL,JTARG,PTARG,
     X		 ETARG,NTARG,NX,DX,NBS,ITRBS,RNODE,AN,AC,H2M,PRT,
     X		 LBSMAX,SN,KIND,NTR,ZN1,ZN2,EOCC,fpot,rcore,SPMEL,BEV)
 
C    PREPARE SPLINE FUNCTIONS
      	CALL SPLINES(NY,ASPL,NYMAX,NYP2)
  		if(VOLCON) then
		  do i=2,5
		    DEF(i) = DEFH(i)
		  enddo
		endif
      	endif
	if(NBS.eq.0.or.NLLAG.eq.0) NY=0
 	
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
	if(nmax.ne.0.and..not.repeat) then
           pwfile = fpot(1:lnblnk(fpot))//'.pw'
!         open (8,file =pwfile,
!    x		access='sequential',form='formatted',status='unknown')
          open (14,file =fpot(1:lnblnk(fpot))//'.eig',
     x		access='sequential',form='formatted',status='unknown')
          open (18,file =fpot(1:lnblnk(fpot))//'.wf',
     x		access='sequential',form='formatted',status='unknown')
          open (35,file =fpot(1:lnblnk(fpot))//'.gseig',
     x		access='sequential',form='formatted',status='unknown')
	  if(POTPARTS) then
!         open (37,file =fpot(1:lnblnk(fpot))//'.vha',
!    x		access='sequential',form='formatted',status='unknown')
	  if(wfnrr) then
          open (38,file =fpot(1:lnblnk(fpot))//'.wft',
     x		access='sequential',form='formatted',status='unknown')
	  else
          open (38,file =fpot(1:lnblnk(fpot))//'.vrr',
     x		access='sequential',form='formatted',status='unknown')
	  endif
	  if(EQN.eq.'F')
     x    open (39,file =fpot(1:lnblnk(fpot))//'.wfy',
     x		access='sequential',form='formatted',status='unknown')
	  endif

 	 if((MOMDIS.or.NMAX.lt.0).and.EMAX.gt.EMIN.and.MEIGS/=1) then
          open (11,file =fpot(1:lnblnk(fpot))//'.be1df',
     x		access='sequential',form='formatted',status='unknown')
          open (12,file =fpot(1:lnblnk(fpot))//'.be2df',
     x		access='sequential',form='formatted',status='unknown')
          open (13,file =fpot(1:lnblnk(fpot))//'.strdf',
     x		access='sequential',form='formatted',status='unknown')
          open (21,file =fpot(1:lnblnk(fpot))//'.be1lt',
     x		access='sequential',form='formatted',status='unknown')
          open (22,file =fpot(1:lnblnk(fpot))//'.be2lt',
     x		access='sequential',form='formatted',status='unknown')
          open (23,file =fpot(1:lnblnk(fpot))//'.strlt',
     x		access='sequential',form='formatted',status='unknown')
	 endif

 	 if(MOMDIS) then
c          open (19,file =fpot(1:lnblnk(fpot))//'.wfp',
c     x		access='sequential',form='formatted',status='unknown')
          open (44,file =fpot(1:lnblnk(fpot))//'.md',
     x		access='sequential',form='formatted',status='unknown')
          open (45,file =fpot(1:lnblnk(fpot))//'.sph',
     x		access='sequential',form='formatted',status='unknown')
!          open (62,file =fpot(1:lnblnk(fpot))//'.owf',
!     x		access='sequential',form='formatted',status='unknown')
          open (48,file =fpot(1:lnblnk(fpot))//'.wf2',
     x		access='sequential',form='formatted',status='unknown')
          open (63,file =fpot(1:lnblnk(fpot))//'.owf-gr',
     x		access='sequential',form='formatted',status='unknown')
          open (164,file =fpot(1:lnblnk(fpot))//'.owfanc',
     x		access='sequential',form='formatted',status='unknown')
          open (78,file =fpot(1:lnblnk(fpot))//'.gs',
     x		access='sequential',form='unformatted',status='unknown')
c          open (79,file =fpot(1:lnblnk(fpot))//'.rr',
          open (79,file ='sturm.rr',
     x		access='sequential',form='formatted',status='unknown')
	 endif
	endif
        if(PRIPOT) open (87,file =fpot(1:lnblnk(fpot))//'.fesh',
     x		access='sequential',form='formatted',status='unknown')
        if(PRIPOT) open (86,file =fpot(1:lnblnk(fpot))//'.fosh',
     x		access='sequential',form='formatted',status='unknown')

!	if(EQN.eq.'T'.or.EQN.eq.'N') 
!     x    open (28,file =fpot(1:lnblnk(fpot))//'.yt',
!     x		access='sequential',form='formatted',status='unknown')
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C  ENUMERATION OF SETS OF TOTAL ANGULAR MOMENTUM & PARITY:

	XLA = 0.0
	KMAX1 = KMAX
	DO 500 IJT=1,NJT
	 JTOT = JTOTS(IJT)
	   PTY = 1
	   if(PARITIES(IJT)(1:1).eq.'-') PTY = -1
	   NPTY = PTY*PTARG(1)
	   JNNPREF=-1
	   if(PARITIES(IJT)(2:2).eq.'e') JNNPREF=0
	   if(PARITIES(IJT)(2:2).eq.'o') JNNPREF=1
	   NN = (1 - NPTY)/2
	   XLA = IJT
           ACTIVE(1:MAXACT)=.true.
    
C  NOTE: this formula for NN assumes that all target states have 
C	 the same parity!!

	KMAX = ((KMAX1-NN)/2)*2 + NN
	do iff=6,mxfile,4
        write(iff,1420) IJT,JTOT,PSIGN(PTY+2),EOSIGN(JNNPREF+2)
 1420   format(/' **********************************************'/
     X  ' * COUPLED CHANNELS SET',i3,' for J,pi =',f5.1,A1,1x,a1,' *'/,
     x  ' **********************************************'/)
	enddo
	call flush(6)

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C ENUMERATION OF BASIS HH AND CONSTRUCTING THEIR REPRESENTATIONS IN 
C TERMS OF THE "(NC)N" OR "(NN)C" HH
	allocate(
     &        KK3(1),LL13(1),LL23(1),LLTOT3(1),SSTOT3(1),
     &        KK2(1),LL12(1),LL22(1),LLTOT2(1),SSTOT2(1),
     &	      JNN3(1),II3(1),JNN2(1),II2(1),
     & 	      KKN(1),ICN(1),CTN(1,1),DTN(1,1),
     &          WN1(1,1),MP12(1),IFO(1,3),IO(1,2))

	CALL ENUMFADCRX(1,JTOT,PTY,KMAX,LNNMAX,LNCMAX,SMAX,K2MAX,K3MAX,
     & 	     NTARG,JTARG,PTARG, MAXL, readpw,pwinfile,thresh,opw,
     &       LLMAX,L2MX,KK3,LLTOT3,LL13,LL23,SSTOT3,JNN3,II3,  
     &       KK2,LLTOT2,LL12,LL22,SSTOT2,JNN2,II2,MCH,JNNMX,JNNPREF,
     &       IMAX3,IMAX2,LDMIN,LDMAX,L1MAX,L2MAX,nooddcn,nooddnn)

	deallocate(
     &        KK3,LL13,LL23,LLTOT3,SSTOT3,KK2,LL12,LL22,LLTOT2,SSTOT2,
     &	      JNN3,II3,JNN2,II2, KKN,ICN,CTN,DTN,WN1,MP12,IFO,IO)

	IMAX = IMAX2+IMAX3
	MCH = IMAX
	allocate(
     &        KK3(MCH),LL13(MCH),LL23(MCH),LLTOT3(MCH),SSTOT3(MCH),
     &        KK2(MCH),LL12(MCH),LL22(MCH),LLTOT2(MCH),SSTOT2(MCH),
     &	      JNN3(MCH),II3(MCH),JNN2(MCH),II2(MCH),
     & 	      KKN(MCH),ICN(MCH),CTN(MCH,MCH),DTN(MCH,MCH),
     &          WN1(MCH,MCH),MP12(MCH),IFO(MCH,3),IO(MCH,2))
	MLT = max(abs(LDMIN),abs(LDMAX))+1
      	allocate(PJ(0:MNM,0:MAXL,-MLT:MLT,MJAC))

	CALL ENUMFADCRX(2,JTOT,PTY,KMAX,LNNMAX,LNCMAX,SMAX,K2MAX,K3MAX,
     & 	     NTARG,JTARG,PTARG, MAXL, readpw,pwinfile,thresh,opw,
     &       LLMAX,L2MX,KK3,LLTOT3,LL13,LL23,SSTOT3,JNN3,II3,  
     &       KK2,LLTOT2,LL12,LL22,SSTOT2,JNN2,II2,MCH,JNNMX,JNNPREF,
     &       IMAX3,IMAX2,LDMIN,LDMAX,L1MAX,L2MAX,nooddcn,nooddnn)

	IMAXDG = IMAX
	 IMAXF = 0
	 if(FESH) then
           do I=1,IMAX2
	     if(KK2(I).le.abs(Kmaxf(II2(I))).and.EQN.ne.'T') 
     & 			IMAXF=IMAXF+1
	   enddo
           do I=1,IMAX3
	     if(KK3(I).le.abs(Kmaxf(II3(I))).and.EQN.ne.'Y')
     & 			IMAXF=IMAXF+1
	   enddo
	 endif
	IMAXDG = 0
	IIMAX=0
	if(NMAX.ne.0) then
		if(EQN.eq.'F'.or.EQN.eq.'N') IMAXDG=IMAX
		if(EQN.eq.'T') IMAXDG=IMAX3
		if(EQN.eq.'Y') IMAXDG=IMAX2
		IIMAX=(MNMAX+1)*IMAXDG
	   endif
	if(FESH) IMAXDG = min(IMAXDG,IMAXF)
	IIMAX=(MNMAX+1)*IMAXDG
	IIR3 = IIMAX/(MNMAX+1) + 1
	MCH3 = max(IIR3,IMAXDG)
	MLL = IMAX*(MNMAX+1)
	ML  = MCH3*(MNMAX+1)
	MLNC = LNCMAX
	MLNN = LNNMAX

	if(MEIGSI==0) then
	  MEIGS=IIMAX
	else if(MEIGS.lt.IIMAX) then
		if(EMAX.gt.EMIN) then
		  write(6,*) ' MEIGS should be >',IIMAX,' for continuum'
c		  stop
		else
		  write(6,*) ' ONLY LOOK FOR LOWEST ',MEIGS,' STATES'
		  NMAX=MNMAX
		endif
	endif
	NEIGS=0
	if(NMAX.lt.0) NEIGS = IIMAX
	if(NMAX.gt.0) NEIGS = min(ML,MEIGS,4)

	do iff=6,mxfile,4
	WRITE(iff,1425) IMAX2,IMAX3,IMAX
1425   format(' The number of basis Y(2) HH=',I4, 
     x  ', Y(3) HH=',I4,',  all HH =',I4)

	IMAX2 = min(IMAX2,MCH)
	IMAX3 = min(IMAX3,MCH)
	if(IMAX.eq.0) go to 490
      DO 1430 I1=1,IMAX2,25
        NCHL = min(I1+24,IMAX2)
	write(iff,1480)
	write(iff,1480)'i:',(mod(i,1000),i=I1,NCHL)
	write(iff,1480)'K2',(kk2(i),i=I1,NCHL)
	write(iff,1480)'L2',(lltot2(i),i=I1,NCHL)
	write(iff,1480)'S2',(sstot2(i),i=I1,NCHL)
	write(iff,1480)'l12',(ll12(i),i=I1,NCHL)
 	write(iff,1480)'l22',(ll22(i),i=I1,NCHL)
 	write(iff,1480)'Jnn',(JNN2(i),i=I1,NCHL)
 1430	write(iff,1480)'I#',(II2(i),i=I1,NCHL)

      DO 1440 I1=1,IMAX3,25
        NCHL = min(I1+24,IMAX3)
	write(iff,1480)
	write(iff,1480)'i:',(mod(i+IMAX2,1000),i=I1,NCHL)
	write(iff,1480)'K3',(kk3(i),i=I1,NCHL)
     	write(iff,1480)'L3',(lltot3(i),i=I1,NCHL)
     	write(iff,1480)'S3',(sstot3(i),i=I1,NCHL)
	write(iff,1480)'l13',(ll13(i),i=I1,NCHL)
 	write(iff,1480)'l23',(ll23(i),i=I1,NCHL)
 	write(iff,1480)'Jnn',(JNN3(i),i=I1,NCHL)
 1440	write(iff,1480)'I#',(II3(i),i=I1,NCHL)
 1480   format(1x,A3,25I3,:,/(3x,25i3))

      	WRITE(iff,1490) 
!     X		       MLAG,MJAC,MCH,MCH3, MCH3,MLNC,  MLNN,  MKMAX,
!     X				MNMAX,MX,NYMAX,MT,MEIGS,
     X                 NLAG,NJAC,IMAX,IMAXDG,IIR3,LNCMAX,LNNMAX,KMAX,
     X				MNMAX,NX,NY,NTARG,NEIGS
 1490 FORMAT(/' PARAMETERS MLAG MJAC  MCH MCH3 MCH3 MLNC MLNN',
     X                    ' MKMAX  MNMAX    MX NYMAX  MT MEIGS',
!     X / '  ALLOWED ',I6,5I5,5I6,I4,I6,
     X / '  REQUIRED',I6,5I5,5I6,I4,I6/)
	enddo
        IF(NLAG.gt.MLAG) stop 'MLAG'
        IF(NMAX.ne.0.and.NLAG.lt.9) stop 'NLAG<9'
	if(NJAC.gt.MJAC) stop 'MJAC'
	if(IMAX.gt.MCH) stop 'MCH'
	if(IIMAX.gt.ML) stop 'ML:MCH3'
!	if(IMAXDG.gt.MCH3) stop 'MCH3'		! previous line is the real test
	if(LNCMAX.gt.MLNC) stop 'MLNC'
	if(LNNMAX.gt.MLNN) stop 'MLNN'
	if(KMAX.gt.MKMAX) stop 'MKMAX'
	if(MNMAX.gt.MNMAX) stop 'MNMAX'
	if(LNNMAX.gt.MAXL) stop 'MAXL'
	if(LNCMAX.gt.MAXL) stop 'MAXL'
	if(NMAX.gt.NLAG) stop 'NLAG'
        if(NMAX.lt.0.and.IIMAX.gt.MEIGS) stop 'MEIGS' 
	if(NTARG.gt.MT) stop 'MT'
      	IF(NX.gt.MX.or.NY.gt.NYMAX) then
         write(6,*) 'NX =',NX,' > ',MX,'  OR NY =',NY,' > ',NYMAX
         stop
         endif

	do I=1,IMAX3
	   KK2(IMAX2+I) = KK3(I)
	   LL12(IMAX2+I) = LL13(I)
	   LL22(IMAX2+I) = LL23(I)
	   lltot2(IMAX2+I) = lltot3(I)
	   sstot2(IMAX2+I) = sstot3(I)
	   JNN2(IMAX2+I) = JNN3(I)
	   II2(IMAX2+I) = II3(I)
	enddo
	call flush(6)

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C ANGULAR MATRIX ELEMENTS

C STORING THE KINEMATICAL COEFFICIENTS
	CALL QUAJAC1(XJ,WJ,NJAC)
          write(6,*)
          write(6,*) 'All Gauss-laguerre points:'
          write(6,755) (RR*XL(j),j=1,NLAG)
          write(6,*)
	  if(NMAX.ne.0) then
          write(6,*) 'Gauss-laguerre points for NMAX =',MNMAX,':'
          write(6,755) (RR*XLAG(j),j=1,MNMAX)
	  endif
755     format(' Radii:   ',7f10.3,:,/(10x,7f10.3))
	  RMAX = RR*XLAG(MNMAX)
          write(6,*)
	if(NY.ne.0.and.YMAX.lt.min(RINNER,RLOC,RMAX)-1.) then
	   write(6,310) YMAX,min(RINNER,RLOC,RMAX)
310	   format(' Insufficient number of splines.'/
     x		  ' YMAX (',f8.3,') should be >',F8.3,' fm')
c	   stop 'YMAX'
	  endif
	  call flush(6)


C
C----  CALCULATE COUPLING TERMS WW and NORMALISATION MATRIX WN1
	allocate(WW(MCH,MCH,MLAG))
c
	CALL FADCOX(JTOT,AC,AN,WJ,XJ,PJ,WN1,MP12,EQN,KMAX,RINNER,
     x     KK3,LL13,LL23,LLTOT3,SSTOT3,KK2,LL12,LL22,LLTOT2,SSTOT2,
     x     JTARG,JNN3,II3,JNN2,II2, XL,RR,.false.,
     X     WW, MLAG,MJAC,MCH,MAXL,MLNN,MAXL2, MNM,MLT,MLNC,
     x     NLAG,NJAC,IMAX2,IMAX3,LNNMAX,L1MAX,L2MAX,LNCMAX,NM,
     x     NN,LDMIN,LDMAX,MONOPEX)
	write(6,*) ' Potential matrix elements calculated'
	call flush(6)
 
	   write(mxfile,*) ' Hamiltonian Matrix in Faddeev Basis:'
     	  CALL PRINTCO(NMAX,mxfile,RR,XL,NLAG,XLAG,PRIPOT,IMAX,
     x		       IMAX,WW,WN1,MCH,1,EQN)

          CALL REDHAM(EQN,WN1,WW,MCH,NLAG, CTN,DTN,KKN,ICN,
     x	   	KK2,II2,IMAX2,IMAX3,IMAX,IMAX2H,IMAX3H,IMAXH,.true.)
	    IMAXN = IMAXH

	   write(mxfile,*) ' Hamiltonian Matrix in Schrod. Basis:'
     	  CALL PRINTCO(NMAX,mxfile,RR,XL,NLAG,XLAG,PRIPOT,IMAX,
     x		       IMAXH,WW,WN1,MCH,2,EQN)

	    I1 = 1
	    if(EQN.eq.'T') I1 = IMAX2+1
	  if(FESH) then

	   CALL FESHBACH(WW,RR,NLAG,XL,MCH,Kmaxf,IMAXH,KK2(I1),KKN,ICN,
     x	     II2(I1),ETARG,EQN,EFesh,H2M,IFO,IMAXF, PRIPOT,
     X	     MCH,NPLAG,NLLAG,DROPS(IJT),EOCC,JTOT,JNN2(I1))
	    if(EQN.eq.'T') then
!?	 	IMAX3=IMAXF
	 	IMAXH=IMAXF
	    else
	 	IMAXH=IMAXF
	    endif
	   write(mxfile,*) ' Hamiltonian Matrix in Feshbach Basis:'
     	   CALL PRINTCO(NMAX,mxfile,RR,XL,NLAG,XLAG,PRIPOT,IMAX,
     x		       IMAXH,WW,WN1,MCH,3,EQN)
	  endif

	  if(callsusy)  then

	   write(6,*) ' Calling SUSY with KmaxSUSY =',KmaxSUSY
	   call susy(ww,mch,IMAXH,nlag,rr,xl,KK2(I1),
     x			kmaxsusy,drho,rhomax)

	   write(mxfile,*) ' Hamiltonian Matrix after SUSY transform:'
     	   CALL PRINTCO(NMAX,mxfile,RR,XL,NLAG,XLAG,PRIPOT,IMAX,
     x		       IMAXH,WW,WN1,MCH,3,EQN)
	   endif

	if(PRIPOT) then
        CALL VDIAG(RR,WW,MCH,XL,NLAG,IMAXH,
     x		   KK2(I1),KKN,EQN,H2M,FESH,IFO,II2,ICN,ETARG)
	endif
	call flush(6)

C**************************************************************************
	IF(NMAX.eq.0) THEN
C---------------------------------- GIVE FILES FOR STURM DIAGONALISATION:

       if(IJT.eq.1) then
C---------------------------------- OPEN FILES 
       fmel =fpot(1:lnblnk(fpot))//'.mel'
       fspec=fpot(1:lnblnk(fpot))//'.spec'
       focc =fpot(1:lnblnk(fpot))//'.occ'
       write(6,*)  'Writing files: ',
     x        fmel(1:lnblnk(fmel)),', ',fspec(1:lnblnk(fspec)),
     x        ', ',focc(1:lnblnk(focc))
       write(10,*)  'Writing files: ',
     x        fmel(1:lnblnk(fmel)),',',fspec(1:lnblnk(fspec))
            open (40,file = fmel,access = 'sequential',
     x         form='unformatted',status = 'unknown')
            open (41,file =fspec,access = 'sequential',
     x         form='formatted',status = 'unknown')
            open (15,file =focc,access = 'sequential',
     x         form='unformatted',status = 'unknown')
       endif
c				Write out channels in order IO(i,1),i=1,IMAX
c				IO(*,2) is reverse mapping
	YTORDER = .true.
	YTORDER = .false.
	 if(YTORDER.or.EQN.eq.'Y'.or.EQN.eq.'N') then
	   do 100 i=1,IMAX
	   IO(i,1) = i
100	   IO(i,2) = i
	 else
	   do 101 i=1,IMAX3
	   IO(i,1) = IMAX2+i
101	   IO(IMAX2+i,2) = i
	   do 1011 i=1,IMAX2
	   IO(IMAX3+i,1) = i
1011	   IO(i,2) = i+IMAX3
	 endif
C
C---------------------------------- CALCULATE FORBIDDEN STATES IN HH BASIS:
	IF(NY.gt.0.or.N3BLOCK>0)
     *	call PPX(NBS,LV,JV,JTOT,PTY,NX,DX,NY,DY,YBS,ASPL,NLAG,RR,KAPP,
     1              IMAX2,kk2,lltot2,sstot2,ll12,ll22,LNCMAX,IMAX,NSRC,
     2              NTARG,JTARG,JNN2,II2,PTARG,LDMIN,LDMAX,MAXEQ,
     2              KIND,AC,AN,SN,WN1,NJAC,XJ,WJ,XL,WL,PJ,IO,NKILL,
     3              MLAG,MJAC,NYMAX,MX,NYP2,MCH,MCH,MNM,MAXL,MLT,MLL,
     5		    ML,MNMAX,0,RL,WM,PRIPOT,EQN,MBS,ICV,JTV,KNF,KNL,
     6		    NLLAG,CTN,IMAXN,FESH,IFO,IMAXF,EPS2,N3BLOCK)

!     	call TRAX(NTR,LV,JV,JTOT,PTY,NX,DX,YBS,NLAG,RR,
!    1              IMAX2,kk2,lltot2,sstot2,ll12,ll22,LNCMAX,IMAX,
!    2              NTARG,JTARG,JNN2,II2,PTARG,LDMIN,LDMAX,NZERO,MAXEQ,
!    2              KIND,AC,AN,SN,WN1,NJAC,XJ,WJ,XL,PJ,
!    3              MJAC,MX,MCH,MCH,MNM,MAXL,MLT,MNMAX,
!    4		    PRIPOT,EQN,MBS,ICV,JTV,KNF,KNL)

	call REDCHS(EQN,.false.,WN1,CTN,JNN3,II3,JNN2,II2,
     x     KK3,LL13,LL23,LLTOT3,SSTOT3,KK2,LL12,LL22,LLTOT2,SSTOT2,
     x	   KKN,ICN,IMAXN,IMAXH,MCH,IMAX2,IMAX3,IMAX,FESH,IFO,IMAXF)

c---------------------------------- write files 

       if(ijt.eq.1) then
	scent=1.5d0
	lxtra=9
	mfad = 3
	if(eqn.eq.'N') mfad=4
	if(eqn.eq.'T') mfad=1
	symm = .false.
	if(eqn.eq.'N'.or.eqn.eq.'T') symm=.true.
	   ik1=3; ik2=5
	   if(ZEFF>0.001) then
	    ik1=1; ik2=3
	   endif
	ipmax = ik2
	ncoup = 4
	isonc = .false.
	isonc = isonc .and. ntarg.eq.1.and.abs(jtarg(1)-.5).lt.1e-5
	write(41,99)   header
	write(41,*) real(h2m),real(coulcn)
	write(41,102) rr,rr,nlag,rr,rr,nllag,rinner
102	format(2f8.4,i5,2f8.4,i5,f10.5)
	write(41,*) 3,scent,lxtra,ncoup,ipmax,mfad,symm,.true.,1,ntarg,0
	write(41,'(''  K  L  S L1 L2Jnn Ic s1 s2 JT'')')
* multipliers, jgt
	write(41,'(''  1  1  1  1  1  1  2  2  2  2 10'')')
* 4 coupling orders
	write(41,'(''  4  5  2  8  9  3  3  2  6  6  7 10'')')
* masses, charges, sizes
	write(41,*) an,an,ac, zn1,zn2,zc,rn,rn,rcore
        write(41,1045) 'n1',1,sn,0d0,0d0,0d0,1
        write(41,1045) 'n2',1,sn,0d0,0d0,0d0,1
        write(41,1045) 'core',ntarg,ktarg,q0core,0d0,
     X			(etarg(i),ptarg(i),i=1,ntarg)
1045      format(a8,i3,f4.1,2f10.4,10(f8.4,i4))
	write(41,1046) isonc,real(ttnc),isonc,real(ttnc),.true.,real(tt)
1046 	  format(3(L2,f4.1))
*				Labelling of nuclei in successive ICHL:
	if(mfad.gt.1) write(41,*) (3,1,2,i=1,mfad)
       endif

   	write(41,105) jtot,PARITIES(ijt)
105   	format(' Coupled Channels Set ',f5.1,1x,a2)

	  write(41,106) nint(2*jtot),pty,imax,0,xla
106	  format(4i5,f10.5)

	if(eqn.eq.'F') then
	  if(ytorder) write(41,*) (2,i=1,imax2),(1,i=1,imax3)
	  if(.not.ytorder) write(41,*) (1,i=1,imax3),(2,i=1,imax2)
	 else if(eqn.eq.'N') then
	  write(41,*) (1,i=1,min(imax3,imax)),(4,i=imax3+1,imax)
	 else if(eqn.eq.'T') then
	  write(41,*) (1,i=1,min(imax3,imax))
	 else if(eqn.eq.'Y') then
	  write(41,*) (2,i=1,imax)
	 endif
*				mfad>1: Particles always in order: core,n,n
	if(mfad.gt.1) then
	write(41,*) (ii2(io(i,1)),i=1,imax)
	write(41,*) (1,i=1,imax)
	write(41,*) (1,i=1,imax)
	else
*				mfad=1: Particles always in order: n,n,core
*					since 3,1,2 not written in this case!
	write(41,*) (1,i=1,imax)
	write(41,*) (1,i=1,imax)
	write(41,*) (ii2(io(i,1)),i=1,imax)
	endif

c quantum numbers written in order  k,ltot,s,l1,l2,jn,i
 	write(41,*) (kk2(io(i,1)),i=1,imax)
 	write(41,*) (lltot2(io(i,1)),i=1,imax)
 	write(41,*) (sstot2(io(i,1)),i=1,imax)
   	write(41,*) (ll12(io(i,1)),i=1,imax)
   	write(41,*) (ll22(io(i,1)),i=1,imax)
	write(41,*) (jnn2(io(i,1)),i=1,imax)
	write(41,*) (nint(2*jtarg(ii2(io(i,1)))),i=1,imax)
	write(41,*) (nint(2*sn),i=1,imax)
	write(41,*) (nint(2*sn),i=1,imax)
	write(41,*) (nint(2*jtot),i=1,imax)
	write(41,*) nsrc,NKILL*0

C				Find asymptopia coefficients,
	allocate(cf(mch,mch,ik2))
        nlg2 = nlag *9/10
        RHO1 = xl(nlg2)*RR
        RHO2 = xl(nlag)*RR
        do 760 JPO1=1,imax
        do 760 JPO2=1,imax
758       CF(JPO1,JPO2,:) = 0.0
        V1 = ww(JPO1,JPO2,nlg2)
        V2 = ww(JPO1,JPO2,nlag)
        DD = 1d0/(RHO2**2 - RHO1**2)

       if(ipmax.ge.ik2-1) then
        CF(JPO1,JPO2,ik1) = (RHO2**ik2 * V2 - RHO1**ik2 * V1) * DD
        CF(JPO1,JPO2,ik2) = (RHO1**ik1 * V1 - RHO2**ik1 * V2) * DD *
     x                          (RHO1*RHO2)**2
       else
        CF(JPO1,JPO2,ik1) = RHO2**ik1 * V2
        CF(JPO1,JPO2,ik2) = 0d0
       endif
760	continue
	if(eqn.eq.'F') then
        do 762 j=1,imax
        do 762 k=1,imax
762     write(40) (ww(io(j,1),io(k,1),i),i=1,nlag),
!     X	0d0,0d0,cf(io(j,1),io(k,1),1),0d0,cf(io(j,1),io(k,1),1)
     X	(cf(io(j,1),io(k,1),i),i=1,ik2)
        do 763 i=1,imax
763     write(40) (wn1(io(i,1),io(j,1)),j=1,imax)
        write(40) (mp12(io(i,1)),i=1,imax)
 	else
        do 765 j=1,imax
        do 765 k=j,imax
c			ww has already been shifted in redham
c765     write(40) (ww(io(j,1),io(k,1),i),i=1,nlag)
765     write(40) (ww(j,k,i),i=1,nlag),  !!0d0,0d0,cf(j,k,1),0d0,cf(j,k,2)
     X	(cf(j,k,i),i=1,ik2)
	endif
	deallocate(cf)

	else
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  Find eigenstates using Gauss-Laguerre basis functions:
C
	allocate (RL(0:MNMAX,1:NLAG),WM(ML,ML))
        allocate (VECSR(MLL,MEIGS),VALR(MEIGS),isr(MEIGS))
	CALL EIGENS(NBS,LV,JV,JTOT,PTY,NX,DX,NY,DY,YBS,ASPL,NLAG,
     1            RR,KAPP,KK2,LLTOT2,SSTOT2,LL12,LL22,II2,JNN2,KIND,
     1            LNCMAX,NSRC,KK3,LLTOT3,SSTOT3,LL13,LL23,II3,JNN3,
     2            JTARG,PTARG,TT,LDMIN,LDMAX,L2MAX,SMAX, RMAX,NLLAG,
     T       IMAX2,IMAX3,IMAX,ZC,AC,AN,SN,RN,WN1,NJAC,XJ,WJ,XL,WL,PJ,
     3            MLAG,MJAC,NYMAX,MX,NYP2,MCH,MCH3,MNM,MAXL,MLT,MKMAX,
     5		  ML,MLL,MNMAX,NMAX,RL,WM,PRIPOT,EQN,ZEFF,coulcn,
     6		  H2M,ETARG,VALR,EMIN,VECSR,PSIGN,NTR,PRT,
     7            WW,mxfile,IJT,MEIGS,MBS,ICV,JTV,KNF,KNL,MAXEQ,
     8		  isr,nfound,MOMDIS,IMAX2Y,IMAX2Z,IMAXH,RCORE,IO,
     a 		  EMAX,DE,NN,EPS2,BEV,N3BLOCK,BLOCH,RMATR,BCON,
     b		  CTN,DTN,KKN,ICN,IMAXN,FESH,IFO,IMAXF,abs(Kmaxf))

c	if(.false..and.NY.eq.0.and.nfound.le.3.and.EQN.eq.'F') then
	if(POTPARTS) then
c				Analyze the output bound states,
C				using RL(*,*) G-Laguerre basis fntns
        CALL VERTEX(JTOT,PTY,AC,AN,WJ,XJ,PJ,WN1,MP12,EQN,MKMAX,
     x     KK3,LL13,LL23,LLTOT3,SSTOT3,KK2,LL12,LL22,LLTOT2,SSTOT2,
     x     JTARG,JNN3,II3,JNN2,II2, XL,WL,RR,RL,MNMAX,RINNER,IMAX,H2M,
     x	   WW, MLAG,MJAC,MCH,MAXL,MLNN,MAXL2, MNM,MLT,MLNC,MLL,MEIGS,
     x     NLAG,NJAC,IMAX2,IMAX3,LNNMAX,L1MAX,L2MAX,LNCMAX,SMAX,NM,
     x     NN,LDMIN,LDMAX,isr,nfound,fpot,MONOPEX,
     X     VECSR,VALR,CTN,DTN,KKN,ICN,IFO,FESH,wfnrr)
	endif
	deallocate (RL)
	deallocate (WM)
	deallocate (VECSR)
	deallocate (VALR,isr)

	endif

	if(EQN.eq.'T') close(28)
	if(FESH) close(24)
	close(25)
	deallocate (WW)
490	deallocate(KK3,LL13,LL23,LLTOT3,SSTOT3,KK2,LL12,LL22,
     &	      LLTOT2,SSTOT2,JNN3,II3,JNN2,II2,KKN,ICN,CTN,DTN,
     &          WN1,MP12,IFO,IO,PJ)

500	continue
	stop
	if(EQN.ne.' ')go to 600
      	READ(5,*,end=600) NTARG,KTARG,(DEF(I),I=2,5)
	write(6,*) '###### REPEATING WITH NEW DEFORMATIONS #####'
	write(6,*) '###### REPEATING WITH OCCUPIED STATES  #####'
	VOLCON = NTARG .lt.0
	NTARG = abs(NTARG)
	DO 595 KKKMAX=5,2,-1
595	IF(abs(DEF(KKKMAX)).gt.1e-10) go to 596
	KKKMAX=0
596     WRITE(6,1063) NTARG,KTARG,KKKMAX,(DEF(ik),ik=2,max(2,KKKMAX))
	repeat = .true. 	
	GO TO 1400
600	stop
	end
