      SUBROUTINE FESHBACH(WW,RR,NLAG,XL,MCH,KMAXF,NCH,KVAL,KKN,ICN,II2,
     X	ETARG,EQN,EFESH,H2M,IO,NF,PRIPOT,MXM,NPLAG,NLLAG,NDROP,EOCC,
     X  JTOT,JNN)
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION  WW(MCH,MCH,NLAG),XL(NLAG),KVAL(NCH),KKN(NCH),
     X		WWL(MXM,MXM)
      CHARACTER EQN
      DIMENSION  XM(MXM,MXM),B(MXM,MXM),GG(MXM,MXM),ETARG(10),JNN(NCH)
      INTEGER II2(MCH),ICN(MCH),IO(MCH,3),EO(MCH),IPIV(MCH),KMAXF(3)
      LOGICAL SING,SHOW,DROPPED,OK,PRIPOT
      real*8,allocatable::  WWINC(:,:,:)

!      write(6,*)'FESHBACH: RR,MCH,NLAG,NCH=',real(RR),MCH,NLAG,NCH
!      write(6,*)'FESHBACH: NPLAG,NLLAG,NDROP=',NPLAG,NLLAG,NDROP,EOCC
!      write(6,*)'FESHBACH: ETARG =',ETARG
c	Do non-local Pauli projection up to NLLAG (incl),
c	do local Pauli projection from NLLAG to NPLAG (incl), dropping NDROP
c	No Pauli projection beyond NPLAG

      if(NCH.gt.MXM) stop 'MXM'
c
c		NF counts channels to include  -> IO(*,1)
c		NC counts channels to eliminate  -> IO(*,2)
C		IO(*,3) indexes from original to new channel (or 0 if none)
       NF = 0
       NC = 0
       KMAXFF = 0
       do 4 I=1,NCH
	KK = KVAL(I)
	if(EQN.eq.'N') KK = KKN(I)
	IC = II2(I)
	if(EQN.eq.'N') IC = ICN(I)
        OK = KK.le.KMAXF(IC)
!        OK = KK.le.abs(KMAXF(IC))
!        if(KMAXF(IC).lt.0.and.EQN.ne.'N'.and.mod(JTOT-JNN(I),2).ne.0) 
!     X				OK=.false.
        if(OK) then

         NF = NF+1
         IO(NF,1) = I
         IO(I,3) = NF
        else
         NC = NC+1
         IO(NC,2) = I
         IO(I,3) = 0
	endif
	KMAXFF = max(KMAXFF,abs(KMAXF(IC)))
4	continue
5	write(6,10) NF,NC,NDROP
10        format('  Feshbach reduction to ',i3,' channels, omit',i4,
     X		' after dropping ',i3,' levels')
*	NC = NCH - NF
!	open(24,access='direct',recl=max(1,8*NC*NF),status='scratch')	
	open(24,access='direct',recl=max(1,8*NC*NF))
	SHOW = .false.
	EPS = 1d-100
	DROPPED = .false.
	 if(PRIPOT) allocate(WWINC(MCH,MCH,NLAG))
C
C----  REDUCE THE COUPLING TERMS WW  to K<=KMAXF
c
	do 100 k=1,NLAG
	R =  RR*XL(k)
	IDROP = 0
	if(k.ge.NLLAG.and.k.le.NPLAG) IDROP = NDROP
!	 write(6,*) 'k,NLLAG,NPLAG,NDROP,IDROP=',
!     x		k,NLLAG,NPLAG,NDROP,IDROP
	if(IDROP.gt.0) then
c  Calculate full H matrix:
		do 16 I=1,NCH
		do 15 J=1,NCH
15		XM(I,J) = WW(I,J,k)
		KK = KVAL(I)
		if(EQN.eq.'N') KK = KKN(I)
		IC=II2(I)
		if(EQN.eq.'N') IC=ICN(I)
		XM(I,I)=XM(I,I)+ETARG(IC) + H2M*(KK+1.5)*(KK+2.5)/(R*R)
16		continue

C	 	Find NDROP lowest eigenvalues
	  mc = 30
	if(R.gt.60.0) then
c			Find eigenvalues nearest to EOCC
	  eps = 1e-3
	  call  invitrm(XM,MXM,MXM,NCH,GG,B,NDROP,EOCC,eps,mc,
     x			GG(1,2),GG(1,3),.false.)
	  neig = NDROP
	else
c			Find lowest eigenvalues (by finding all first)
          call f02agf(XM,MXM,NCH,GG,GG(1,2),B,MXM,WWL,MCH,
     x                  GG(1,3),IFAIL)
	  neig = NCH

	endif
	  call m01daf(GG(1,1),1,neig,'a',EO,IFAIL)
	  call m01zaf(EO,1,neig,IFAIL)
	 if(PRIPOT) write(105,99) real(R),(GG(EO(i),1),i=1,min(neig,10))
!	 write(6,*) ' Dropping levels at ',(real(GG(EO(i),1)),i=1,NDROP)
	 write(103,*) real(R),(real(GG(EO(i),1)),i=1,NDROP)
	 DROPPED = .true.

c  Recalculate full H matrix for projection operation:
		do 26 I=1,NCH
		do 25 J=1,NCH
25		XM(I,J) = WW(I,J,k)
		KK = KVAL(I)
		if(EQN.eq.'N') KK = KKN(I)
		IC=II2(I)
		if(EQN.eq.'N') IC=ICN(I)
		XM(I,I)=XM(I,I)+ETARG(IC) + H2M*(KK+1.5)*(KK+2.5)/(R*R)
26		continue

C		Do MoveLevels transform to move NDROP lowest levels to ESHIFT
         Eshift=10000.d0
         Eshift=500.d0
		EBAR =  H2M*(KMAXFF+1.5)*(KMAXFF+2.5)/(R*R)
		Eshift = min(Eshift,EBAR*0.5)
         call MoveLevels(XM,MXM,NCH,NDROP,GG(1,2),GG(1,3),B,Eshift,EO)

c  Put back all H matrix after projection operation:
		do 36 I=1,NCH
		do 35 J=1,NCH
35		WW(I,J,k) = XM(I,J)
		KK = KVAL(I)
		if(EQN.eq.'N') KK = KKN(I)
		IC=II2(I)
		if(EQN.eq.'N') IC=ICN(I)
		WW(I,I,k)=WW(I,I,k)-ETARG(IC) - 
     X			H2M*(KK+1.5)*(KK+2.5)/(R*R)
36		continue
	endif

	if(IDROP.ne.0) write(6,40) NF,R,Eshift,
     X   (GG(EO(i),1),i=1,min(10,IDROP))
40        format('  Reduced ',i3,' couplings at R =',F8.3,
     X		' after moving to',F6.1,' the levels',10f9.3)
	if(IDROP.eq.0) write(6,41) NF,R
41        format('  Reduced ',i3,' coupling matrix at R =',F8.3)
	if(NC.eq.0) go to 97
	 IFAIL = 0
	do 60 I=1,NC
	ICI = IO(I,2)
	do 50 J=1,NC
	ICJ = IO(J,2)
50	XM(J,I) = WW(ICI,ICJ,k)
	KK = KVAL(ICI)
	if(EQN.eq.'N') KK = KKN(ICI)
	IC=II2(ICI)
	if(EQN.eq.'N') IC=ICN(ICI)
	XM(I,I)=XM(I,I)+ETARG(IC) + H2M*(KK+1.5)*(KK+2.5)/(R*R)
     X			 - EFESH
60	continue
C
C
C		Now do Feshbach reduction in the Pauli-allowed subspace

C				RHS:
	DO 70 I=1,NC
	ICI = IO(I,2)
	DO 70 J=1,NF
	 ICJ = IO(J,1)
	XM(I,J+NC) = WW(ICJ,ICI,k)
70	B(I,J) = WW(ICI,ICJ,k)

	  call dgetrf(NC,NC,XM,MXM,IPIV,ifail)
		if(ifail.ne.0) then
	     write(6,*)' Eigenstate at ',EOCC,' at rho=',r,'!'
	      stop 'Feshbach'
		endif
          call dgetrs('N',NC,NF,XM,MXM,IPIV,XM(1,NC+1),MXM,info)
!        CALL GAUSSR(NC,NF,MXM,XM,SING,DET,EPS,SHOW)
	DO 75 I=1,NC
	DO 75 J=1,NF
75	GG(J,I) = XM(I,J+NC)
c		Save G matrix for renormalising the Pauli projection operators
	write(24,rec=k) ((GG(J,I),J=1,NF),I=1,NC)


	ONE = 1d0
	ZERO = 1d0
	XM(:,:) = 0.
	call dgemm ('n','n',NF,NF,NC,-ONE,GG,MXM,B,MXM,ZERO,XM,MXM)
	DO 80 I=1,NF
	DO 80 J=1,NF
	  if(PRIPOT) WWINC(I,J,k) = XM(I,J)
80	XM(I,J) = WW(IO(I,1),IO(J,1),k) + XM(I,J)

	if(.false.) then
C				So here Matrix modified in situ
	do 90 ICI=1,NCH
	do 90 ICJ=1,NCH
	WW(ICI,ICJ,k) = 0d0
	 I = IO(ICI,3)
	 J = IO(ICJ,3)
	if(I.ne.0.and.J.ne.0) WW(ICI,ICJ,k) = XM(I,J)
90	continue
	else
C				So here Matrix reformatted from 1
	do 92 ICI=1,NCH
	do 92 ICJ=1,NCH
92	WW(ICI,ICJ,k) = 0d0
	DO 95 I=1,NF
	DO 95 J=1,NF
95	WW(I,J,k) = XM(I,J)
	endif
C			NB:  The quantum numbers are not rearranged yet!

97	if(PRIPOT) then
c			Check all eigenvalues again!!
	do 98 I=1,NF
	 if(NC.eq.0) then
	 do J=1,NF
	 XM(I,J) = WW(I,J,k) 
	 enddo
	 endif
	ICI = IO(I,1)
	KK = KVAL(ICI)
	if(EQN.eq.'N') KK = KKN(ICI)
	IC=II2(ICI)
	if(EQN.eq.'N') IC=ICN(ICI)
	XM(I,I)=XM(I,I)+ETARG(IC) + H2M*(KK+1.5)*(KK+2.5)/(R*R)
98	continue

          call f02agf(XM,MXM,NF,GG,GG(1,2),B,MXM,WWL,MCH,
     x                  GG(1,3),IFAIL)
	  call m01daf(GG(1,1),1,NF,'a',EO,IFAIL)
	  call m01zaf(EO,1,NF,IFAIL)
!	 write(104,*) real(R),(real(R*R*GG(EO(i),1)),i=1,min(NF,5))
	 write(104,99) real(R),(GG(EO(i),1),i=1,min(NF,10))
99      format(f8.3,20f10.3)
!	 i = 2
!	 EF = GG(EO(i),1)
	endif
100	continue
	 if(PRIPOT) then
	   do 105 I=1,min(NF,4)
	     JMAX=min(NF,4)
	     if(EQN.eq.'T'.or.EQN.eq.'N') JMAX=I
	   do 105 J=1,JMAX
	    ICI = 87
	    if(I/=J) ICI=86
	   write(ICI,101) I,J
101	   format('#  Additional Feshbach potentials in coupling ',i4,
     x  	' <- ',i4)
	   do 103 k=1,NLAG
		R =  RR*XL(k)
103	   write(ICI,104) R,WWINC(I,J,k)
104	   format(f8.3,f12.6)
	   write(ICI,*) '&'
105  	   continue
	   deallocate(WWINC)
	   endif
	 if(DROPPED) write(103,*) '&'
	return
	end
C
        subroutine MoveLevels(A,ia,NC,NDROP,pvec,qvec,B,Eshift,NEO)
      	IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      	DIMENSION  A(ia,ia),B(ia,ia),pvec(ia),qvec(ia),NEO(ia)


C		Project Hamiltonian matrix A off occupied states
c
c       i.e. matrix elements for QQ.H.QQ, 
c	where QQ = 1 - |forbidden><forbidden|
c
c
	do 50 ins=1,NDROP
	ns = NEO(ins)
	aconst=0d0
	do i=1,NC
	  pvec(i)=0
	  qvec(i)=0
	  do j=1,NC
	    pvec(i)=pvec(i)+A(i,j)*B(j,ns)
	    qvec(i)=qvec(i)+A(j,i)*B(j,ns)
	  enddo
	  aconst=aconst+pvec(i)*B(i,ns)
	enddo
	aconst = aconst + Eshift
	do i=1,NC
	do j=1,NC
	  A(i,j)=A(i,j)-(B(i,ns)*qvec(j)+B(j,ns)*pvec(i))
     &    +aconst*B(i,ns)*B(j,ns)
	enddo
	enddo
50      continue
        return
        end

