        subroutine laneig(A,ia,ib,n,eigval,eigvec,neigs,eeps,w,
     x                    lanmax,veclan,vecf02,alpha,beta,codiag,b)
        implicit real*8(a-h,o-z)
c
c       Find neigs eigensolutions for Ax=Ex, symmetric A.
c       by Lanczos iterations.
c
c       At end, val(kv)=E, vec(*,kv)=x for kv=1,neigs,
c       A kept.
c
      dimension   codiag(lanmax),vecf02(lanmax,lanmax),
     *            veclan(ib,lanmax),alpha(lanmax),beta(lanmax-1),
     *            b(lanmax)
      dimension   A(ia,n),eigvec(ib,neigs),w(n),eigval(neigs)
c
	nlan = lanmax
c	write(6,*)  ' Laneig: n,ia,lanmax =',n,ia,lanmax
c
c                    ===================================================
c                    DIAGONALISATION AVEC    l a n c z o s    SUBROUTINE
c                    ===================================================
c
                     write(10,'(2(/),1x,120(1h*),/,
     *                    1x,1h*,9x,'' diagonalization has been done '',
     *                    ''with  ===>  l a n c z o s   subroutine'',
     *                    40x,1h*,/,1x,1h*,118x,1h*)')
c
c                     time=secnds(0.0)
c
                     lfail=0
                     iresta=0
                     nlanre=0
                     nnorm=0
                     nscal=0
                     ierf02=99
c
                     call lanczos(nlan,neigs,lfail,iresta,nlanre,nnorm,
     *                            nscal,ierf02,A,n,ia,eigval,eeps,
     *                            codiag,vecf02, lanmax,
     *                            eigvec,w,veclan,alpha,beta,b)
c
c                     time=secnds(time)
c
                     if (lfail.eq.1) then
                        write(10,'(5(/),1x,''message:'',/,
     *                  10x,''number of required lanczos steps : '',
     *                  ''nlan ='',1i6,//,10x,''restart the calcul'',
     *                  ''ation with  nlan > 0'',//)') nlan
                        stop ' error in "lanczos" : lfail=1'
                     end if
c
                     if (lfail.eq.2) then
                        write(10,'(5(/),1x,''message:'',/,
     *                  10x,''number of required lanczos steps : '',
     *                  ''nlan ='',1i6,//,10x,''restart the calcul'',
     *                  ''ation with  nlan  <  lbloc ='',1i6,//)')
     *                                                     nlan,n
                        stop ' error in "lanczos" : lfail=2'
                     end if
c
                     if (lfail.eq.5) then
                        write(10,'(5(/),1x,''message:'',/,10x,
     *                  ''number of required exact lanczos steps : '',
     *                  ''neigs ='',1i6,//,10x,''restart the calcul'',
     *                  ''ation with  neigs  <  nlan ='',1i6,//)')
     *                                                      neigs,nlan
                        stop ' error in "lanczos" : lfail=5'
                     end if
c
                     if (lfail.eq.3) then
                        write(10,'(5(/),1x,''message:'',/,
     *                  10x,''first lanczos step :  ht.!v1> = !0>'',//,
     *                  10x,''restart the calculation'',//)')
                        stop ' error in "lanczos" : lfail=3'
                     end if
c
                     if (lfail.eq.4) then
                        write(10,'(5(/),1x,''message:'',/,10x,''first'',
     *                  '' lanczos step : beta(1) .le. 1.d-06'',//,10x,
     *                  ''   - ht has only one eigval : alpha(1) , '',
     *                  ''degen = lbloc.'',/,10x,''or - the first '',
     *                  ''lanczos vector is an eigvec of ht.'',//,10x,
     *                  ''restart the calculation with'',
     *                  '' another starting vector.'',//)')
                        stop ' error in "lanczos" : lfail=4'
                     end if
c
                     if (ierf02.eq.1) then
                        write(10,'(1x,''message:'',/,10x,''ierf02 ='',
     *                  1i2,''  ==>   error in "f02amf"'',/,10x,
     *                  ''more then  30*nlan  iterations are required'',
     *                  '' to isolate all the eigenvalues'',/)')
     *                                                          ierf02
                        stop
     *                ' error in "lanczos" : output "f02amf" : ierf02=1'
                     end if
c
                     if (iresta.ge.1) then
                        write(10,'(1x,1h*,1x,''message:'',109x,1h*,
     *                  /,1x,1h*,10x,
     *                  ''first restart in the lanczos subroutine'',
     *                  '' at step n:'',1i3,54x,1h*,/,1x,1h*,10x,
     *                  ''==> the hamiltonian has only :'',1i3,
     *                  ''  eigenvalues'',62x,1h*,/,1x,1h*,10x,
     *                  ''total number of restart ='',1i3,80x,1h*)')
     *                                           nlanre,nlanre,iresta
                     else
                        write(10,'(1x,1h*,1x,''message:'',109x,1h*,/,
     *                  1x,1h*,10x,''no restart in the lanczos'',
     *                  '' subroutine'',72x,1h*)')
                     end if
c
                     write(10,'(1x,1h*,1x,''message:'',109x,1h*,/,
     *               1x,1h*,10x,''number of lanczos steps :'',1i5,
     *               10x,''number of exact eigensolutions :'',1i4,
     *               32x,1h*,/,
     *               1x,1h*,10x,''number of lanczos vectors with'',
     *               '' (norm-1).gt.1.d-14 :'',1i6,51x,1h*,/,
     *               1x,1h*,29x,''number of  scal-prod'',
     *               ''.gt.1.d-14 :'',1i6,51x,1h*,1(/,1x,1h*,118x,1h*
     *               ),/,1x,120(1h*))')    
     *                                        nlan,neigs,nnorm,nscal
c
c=======================================================================
c
      write(10,'(/,11x,''Energies : '',1i3,'' ='',2x,
     *                   1f14.9)') 1,eigval(1)
      do l=2,neigs
         write(10,'(11x,''         : '',1i3,'' ='',2x,
     *                   1f14.9)') l,eigval(l)
      end do

	return
	end
