c
c   F. Nunes & I. Thompson, October 1995, modified IJT, Oct 1999.
c   Calculation of the two body three body overlap
c   for a given 3 body wf in the Y hyperspherical basis, assuming the
c   hyper radial part is normalized  Integral(Xsi^2 dr)=1
c
	Subroutine Overlap32(nch2,numr2,step2,tJ2,par2,ll2,jj2,ii2,
     &	  MX,chi2, chi3,nch3max,numr3,step3,ncho,nch3,tJ3,par3,jtarg,
     X    egs,psign,bev,kky,lltoty,jstoty,ll1y,ll2y,jjny,iiy, lncmax,
     X 	  h2m,a3,xj,wj,njac,pj,mnm,maxl,mlt,ni2,ni3,s1,novplot)
	implicit real*8 (a-h,o-z)
	parameter(nch1max=6)
	real*8 chi2(MX,nch2),chi3(nch3max,numr3),probchi3(nch3max)
	real*8 chi1(nch1max,numr2),probchi2(nch2),jj2(nch2),rms2(nch2)
	integer ll2(nch2),ii2(nch2),ly1(nch1max)
	real*8 xj(njac),wj(njac),pj(0:mnm,0:maxl,-mlt:mlt,njac)
	real*8 tj(njac),chi1norm(nch1max),jtarg(10),chi1this(numr2)
	real*8 cf(21),cg(21),chi1rmsr(nch1max),rmsrad(nch1max)
	real *8 simpson,jacnorm
	integer iiy(nch3max),kky(nch3max),lltoty(nch3max),
     &  jstoty(nch3max),ll1y(nch3max),ll2y(nch3max),jjny(nch3max)
	integer par2,par3,LLX
	logical l1,l2,l3,l4,trace,tracet,opened
        character lnames(8),psign(3)
	data lnames / 's','p','d','f','g','h','i','j' /
	parameter(trace=.false.,tracet=.false.)
	COMMON /RESCALE/ VSCALE(0:1),ZN1,ZN2,ZCORE

	aa = sqrt(a3/(a3+1.d0))
	bb = sqrt((a3+1.d0)/(a3+2.d0))
	rm = bb**2
	esep = bev-egs
	xk = sqrt(abs(esep)*rm/h2m)
      hhjac = (aa*bb)**1.5
!!	write(6,*) ' r1 coef ',a3/(a3+1.d0),
!!     X   ' r2 coef ',(a3+1.d0)/(a3+2.d0),' from ',a3,' hhjac =',hhjac
c------------------------------------------------------------
c        goto 20
   	inquire(49,opened=opened)
   	if(.not.opened) 
     &   open(49, file='wf2bodyreal', access= 'sequential',
     &      form='formatted',status='unknown')
     	write(6,*) ' TRY to read wf2bodyreal for overlaps:'
        do i2=1,nch2
        do ir=1,numr2
         read(49,*,end=20) xii2,xiir, xyyy
          chi2(ir,i2)=xyyy
        enddo
        enddo
     	write(6,*) ' Read wf2bodyreal for overlaps.'

20      inquire(48,opened=opened)
   	if(.not.opened) open(48, file='wf2body', 
     &    access= 'sequential',form='formatted',status='unknown')
        do i2=1,nch2
        do ir=1,numr2
	    r = (ir-1)*step2
          write(48,*) r,-r*chi2(ir,i2)
        enddo
          write(48,*) '&'
        enddo

c------------------------------------------------------------
	if(trace) then
c------------------------------------------------------------
c     Check normalization of chi2
c------------------------------------------------------------
	sumchi2=0.d0
	rmschi2=0.d0

	write(62,*) '# nch2 =',nch2
	write(162,*) '# nch2 =',nch2
	do i2=1,nch2
	  probchi2(i2)=0.d0
	  rms2(i2)=0.d0
	  do ir=1,numr2
	    r = (ir-1)*step2
	    probchi2(i2)=probchi2(i2)+chi2(ir,i2)**2*step2*r*r
	    rms2(i2)=rms2(i2)+chi2(ir,i2)**2*step2*r**4
	    write(62,*) real(r),chi2(ir,i2),i2
	    write(162,*) real(r),r*chi2(ir,i2)
	 	call flush(62)
	 	call flush(162)
	  enddo
	    write(62,*) '&'
	    write(162,*) '&'
	  sumchi2=sumchi2+probchi2(i2)
	  rmschi2=rmschi2+rms2(i2)
	enddo
	print*,'Norm of chi2(*):',
     &          (real(probchi2(i2)),i2=1,nch2),';',real(sumchi2)
	rmschi2 = sqrt(rmschi2/sumchi2)
	print*,'Rms of chi2(*):',
     &   (sqrt(real(rms2(i2)/probchi2(i2))),i2=1,nch2),';',real(rmschi2)
	endif
	if(tracet) then
c------------------------------------------------------------
c     Check normalization of chi3
c------------------------------------------------------------
	sumchi3=0.d0
	write(62,*) '# ncho,nch3,step3 =',ncho,nch3,step3
	ii = 0
	do i3=ncho,ncho+nch3-1
	  ii = ii+1
	  probchi3(ii)=0.d0
	  do ir=1,numr3
	    r = ir*step3
	    probchi3(ii)=probchi3(ii)+chi3(i3,ir)**2*step3
	    write(62,*) real(r),chi3(i3,ir),i3
	 	call flush(62)
	  enddo
	    write(62,*) '&'
	  sumchi3=sumchi3+probchi3(ii)
	enddo
	print*,'Norm of probchi3(*):',
     &          (real(probchi3(ii)),ii=1,nch3),';',real(sumchi3)
	endif
c------------------------------------------------------------
c     Check normalization of PJ
c------------------------------------------------------------
	if(.false.) then
	do i3=ncho,ncho+nch3-1
	   LLX=ll1y(i3)
	   LLY=ll2y(i3)
	  if(LLX.le.1) then
           	NN = mod((LLX+LLY),2)
           	LD=(LLX-LLY+NN)/2
           	N=(kky(i3)-LLX-LLY)/2
	  sumpj=0.d0
	  do j=1,njac
	    sumpj=sumpj+wj(j)*PJ(N,LLX,LD,j)**2
	  enddo
	print*,' Norm PJ:  ',i3,LLX,LLY,sumpj
	  endif
	enddo
	endif
c------------------------------------------------------------
c      Use the Jacobi polynomials in the Y basis
c------------------------------------------------------------
	sq8=sqrt(8.d0)
	do j=1,njac
	   tj(j)=0.5d0*acos(xj(j))
	enddo
c------------------------------------------------------------
c     Initialising chi1 and others
c------------------------------------------------------------
	numr1=numr2
	tk3b=sqrt(abs(egs)/20.748)
!	print*,'egs,tk3b: ',egs,tk3b
	tk3b=tk3b * step3
	do i1=1,nch1max
	  do ir1=1,numr1
	  chi1(i1,ir1)=0.d0
	  enddo
	enddo
c------------------------------------------------------------
c    Main loop over all Y 3 body channels
c------------------------------------------------------------
!	s1=0.5d0
	s2=s1
	nch1=1
	lymax=lncmax+int(tJ3)
! 	write(6,*)   ' lncmax,lymax =',lncmax,lymax
	do 100 ly=0,lymax
! 	  if(trace) write(6,*) 'try ly =',ly,';',(-1)**ly,par2,par3
          if((-1)**ly.ne.par2*par3) goto 100
	do 110 ijy=-1,1,2
	  tjy=ly+s2*ijy
	  if(s2.le.0.1.and.ijy>0) goto 110
	  if (tjy.lt.0.d0) goto 110
! 	  if(trace) write(6,*) 'try jy =',tjy,';',tJ2,tJ3
          if (tjy.lt.abs(tJ2-tJ3) .or. tjy.gt.(tJ2+tJ3))
     &    goto 110
! 	  write(6,*) 'try ly,tjy =',ly,tjy
! 	  write(6,*) 'Triangle tJ2,tjy,tJ3 =',tJ2,tjy,tJ3
	do 200 i2=1,nch2
	  tjx=jj2(i2)
	  tlx=ll2(i2)
	   LLX=ll2(i2)
	  ti=jtarg(ii2(i2))
	  slfac = (-1)**nint(tlx-s1-tjx)
	do 300 i3=ncho,ncho+nch3-1
	write(177,*) ' i3 = ',i3
! 	 write(6,*) 'match: ',ll2(i2),ll1y(i3),';',ii2(i2),iiy(i3),';',
!     &        ly,ll2y(i3)
	  if (ll2(i2).ne.ll1y(i3).or.ii2(i2).ne.iiy(i3).or.
     &        ly.ne.ll2y(i3)) goto 300
	  if (nch1.gt.nch1max) then
	    print*,'nch1 exceeded nch1max (overlap32)'
	    return
	  endif
! 	if(trace) write(6,*) 'try i2,i3 =',i2,i3
 	if(trace) write(6,*) 
!	 if(trace) write(6,*) 'lx,ly,i2: ',ll2(i2),ly,ii2(i2)
c------------------------------------------------------------
c     Calculating the Algebra
c------------------------------------------------------------
	  tjn=jjny(i3)
	  tly=ll2y(i3)
	  tltot=lltoty(i3)
	  tstot=jstoty(i3)
	  tkk=kky(i3)
!	  slfac2 = 1.
!	  slfac2 = (-1)**nint(tltot-tstot-tjn) 
!	  slfac2 = slfac
! 	  slfac2 = (-1)**nint(tltot-tstot-tjn) * slfac
	  if(trace) print 401,'angular:',tjx,tjy,tlx,tly,tjn,ti,
     X		tltot,tstot,tkk
	  alg1=(-1)**nint(tJ3+tJ2-tjn-tjx-2*ti)
	  alg2=(-1)**nint(tjn-tltot-tstot)
	  alg3=SIM9J(tlx,tly,tltot,
     &                   s1, s2,tstot,
     &                  tjx,tjy,tjn)
     &           *sqrt((2*tltot+1)*(2*tstot+1)*(2*tjx+1)*(2*tjy+1))
	  alg4=RACAH(ti,tjx,tJ3,tjy,tJ2,tjn)*sqrt((2*tjn+1)*(2*tJ2+1))
	  algebra = alg1 * alg2 * alg3 * alg4
	if(trace) print 402,'Algebra:',alg1,alg2,alg3,alg4,algebra,hhjac
401     format(A10,9F6.1)
402     format(A10,4F8.3,f10.5,f8.4)
	chi1this(:) = 0.0
           	NN = mod(nint(tlx+tly),2)
           	LD=nint(tlx-tly+NN)/2
           	N=nint(tkk-tlx-tly)/2
c------------------------------------------------------------
c     Calculating the Integral
c------------------------------------------------------------
	write(177,*) ' i3 = ',i3
	  do 400 ir1=1,numr1
	    r1=(ir1-1)*step2
	    xintegral=0.d0
	    do 410 ir2=2,numr2
	    simpson=1.d0
      ! Simpson integration
        if(((-1)**ir2).eq.1) simpson=4.d0/3.d0
        if(((-1)**ir2).eq.-1) simpson=2.d0/3.d0
        if(ir2.eq.1.or.ir2.eq.numr2) simpson=1.d0/3.d0
	      r2=(ir2-1)*step2	      
	      y=bb*r1
	      x=aa*r2
	      rho=Sqrt(x*x + y*y)
c      cost=y/rho
c      sint=x/rho
	      jrho=int(rho/step3)
	      if(ir1>1) theta=atan(x/y)
	      if(ir1==1) theta=2d0*atan(1d0)
	      jtheta=0
	      do j=1,njac
	        if (theta.ge.tj(j)) jtheta=j
	      enddo
c------------------------------------------------------------
c     Two Dimension Interpolation of the 3body WF
c------------------------------------------------------------
	      l1=jtheta.ne.0
	      l2=jtheta.ne.njac
	      l3=jrho.ne.0
	      l4=jrho.lt.numr3
	     if(.not.l4) then
               chi3_int=chi3(i3,numr3)*exp(-tk3b*(jrho+1-numr3))
	     else
	      call wf3_int(i3,rho,step3,numr3,nch3max,chi3,chi3_int)
c      write(179,*) i3,rho,chi3(i3,jrho),chi3_int
	     endif
	      arg=(y**2-x**2)/(x**2+y**2)
	      cost=dsqrt(1.d0+arg)
	      sint=dsqrt(1.d0-arg)
	      nnn=mod((llx+ld),2)
	      al=llx+0.5d0
	      bet=llx+nnn-2*ld+0.5d0
              pp=pojac(n,al,bet,arg)
              pjn=jacnorm(n,llx,llx+nnn-2*ld)
c        write(177,*) n,llx,ld,pp,pjn,sint**llx,cost**(llx+nnn-2*ld)
	      chi3pj_new=sq8*chi3_int
     &          *pojac(n,al,bet,arg)
     &          *jacnorm(n,llx,llx+nnn-2*ld)
     &          *sint**llx*cost**(llx+nnn-2*ld)
c               print *,     i3,n,al,bet,arg, pojac(n,al,bet,arg)
	      dthetax=0.
	      if(l1.and.l2)  dthetax=(theta-tj(jtheta))
     &				/(tj(jtheta+1)-tj(jtheta))
	      dthetay=1.d0-dthetax
	      at1=0.d0
	      at2=0.d0
	      at3=0.d0
	      at4=0.d0
	     if(.not.l4) then
	      if (l1) 
     &            at3=dthetay*chi3(i3,numr3)*exp(-tk3b*(jrho+1-numr3))
     &               *PJ(N,LLX,LD,jtheta)
	      if (l2) 
     &            at4=dthetax*chi3(i3,numr3)*exp(-tk3b*(jrho+1-numr3))
     &               *PJ(N,LLX,LD,jtheta+1)
	      chi3pj=(at3+at4)*sq8
	     else
	      dx=(rho-jrho*step3)/step3
	      dy=1.d0-dx
	      if (l1.and.l3) 
     &            at1=dthetay*chi3(i3,jrho)*PJ(N,LLX,LD,jtheta)
	      if (l2.and.l3) 
     &            at2=dthetax*chi3(i3,jrho)*PJ(N,LLX,LD,jtheta+1)
	      if (l1) 
     &            at3=dthetay*chi3(i3,jrho+1)*PJ(N,LLX,LD,jtheta)
	      if (l2) 
     &            at4=dthetax*chi3(i3,jrho+1)*PJ(N,LLX,LD,jtheta+1)
	      chi3pj=(dy*(at1+at2)+dx*(at3+at4))*sq8
	     endif
c      xintegral=xintegral+r2*step2*
	      xintegral=xintegral+r2*step2*simpson*
     &        chi2(ir2,i2)*r2*slfac*rho**(-5.d0/2.d0)*chi3pj    *hhjac
c    &        chi2(ir2,i2)*r2*slfac*rho**(-5.d0/2.d0)*chi3pj_new*hhjac
             write(177,9177) r2,chi3pj,chi3pj_new,llx,i3,chi3_int,llx,ld
9177        format(f8.4,2d13.5,2i3,1d13.5,2i3)
410         continue
            write(177,*) '&'
	    chi1(nch1,ir1)=chi1(nch1,ir1)+algebra*xintegral*r1
	    chi1this(ir1)=chi1this(ir1)+algebra*xintegral*r1
c	    print*,'chi1: ',nch1,ir1,chi1(nch1,ir1)
400       continue
        chi1n = sum(chi1(nch1,1:numr1)**2)*step2
        chi1t = sum(chi1this(1:numr1)**2)*step2
	 write(6,350) i2,i3,chi1t,chi1n !,probchi3(i3-ncho+1)
350	 format('    Norm to i2,i3 =',i2,i4,' is ',f9.5,': cumu',f9.5)
	do i=1,nch1
	  do ir=1,numr1
	    write(163,*) real((ir-1)*step2),chi1this(ir)
	  enddo
	  write(163,*) '&'
	 enddo
300     continue
200     continue
	  i1 = nch1
	  chi1norm(i1)=0.d0
	  chi1rmsr(i1)=0.d0
	  do ir1=1,numr1
	    r=(ir1-1)*step2
	    chi1norm(i1)=chi1norm(i1)+chi1(i1,ir1)**2*step2
	    chi1rmsr(i1)=chi1rmsr(i1)+chi1(i1,ir1)**2*step2*r**2
	  enddo
	  rmsrad(i1)=0
          if(chi1norm(i1).ne.0) then
	  rrrr=chi1rmsr(i1)/chi1norm(i1)
	  if(rrrr.gt.0) rmsrad(i1)=dsqrt(rrrr)
	  endif
!	write(6,115) ' ',nch1,ni2,ni3,lnames(ly+1),nint(2*tjy),
!     X			chi1norm(i1)
	write(6,116) ' ',tJ2,psign(par2+2),bev,ni3,egs,lnames(ly+1),
     X			nint(2*tjy),  chi1norm(i1),rmsrad(i1)
	write(62,115) '#',nch1,ni2,ni3,lnames(ly+1),nint(2*tjy),
     X			chi1norm(i1),rmsrad(i1)
	write(62,116) '#',tJ2,psign(par2+2),bev,ni3,egs,lnames(ly+1),
     X			nint(2*tjy),  chi1norm(i1),rmsrad(i1)
	write(63,115) '#',nch1,ni2,ni3,lnames(ly+1),nint(2*tjy),
     X			chi1norm(i1),rmsrad(i1)
	write(63,116) '#',tJ2,psign(par2+2),bev,ni3,egs,lnames(ly+1),
     X			nint(2*tjy),  chi1norm(i1),rmsrad(i1)
	write(164,115) '#',nch1,ni2,ni3,lnames(ly+1),nint(2*tjy),
     X			chi1norm(i1),rmsrad(i1)
	write(164,116) '#',tJ2,psign(par2+2),bev,ni3,egs,lnames(ly+1),
     X			nint(2*tjy),  chi1norm(i1),rmsrad(i1)
	write(174,115) '#',nch1,ni2,ni3,lnames(ly+1),nint(2*tjy),
     X			chi1norm(i1),rmsrad(i1)
	write(174,116) '#',tJ2,psign(par2+2),bev,ni3,egs,lnames(ly+1),
     X			nint(2*tjy),  chi1norm(i1),rmsrad(i1)
115	format(a1,'  Overlap<',i2,' * 2b:',I3,' |3b:',i3,' >  : ',a1,i1,
     X		'/2',f10.5,' sq.norm.',f8.4,'rms R')
116	format(a1,'  overlap<2b:',f5.1,a1,' @',f8.3,' |3b:',i3,' @',
     X		f8.3,'> = ',a1,i1,'/2 :',f10.5,' sq.norm.',f8.4,'rms R')
	print *,nch1,nch1max
	ly1(nch1) = ly
	print *,' ly1 = ',ly1
	nch1=nch1+1
110     continue
100     continue
	nch1=nch1-1
!	print*,'chi1norms: ',(real(chi1norm(i)),i=1,nch1)
	print*,' '
!	write(62,*) nch1,numr1
!	write(62,*) ((chi1(i1,ir1),ir1=1,numr1),i1=1,nch1)

cdo i=1,nch1
c	rmin = 0.1
c  do ir=int(rmin/step2)+1,numr1
c    r = (ir-1)*step2
c	   write(62,*) real(r),real(chi1(i,ir))
c   enddo
c         write(62,*) '&'
cenddo

	print *,' anc started'
	do i=1,nch1
		ly = ly1(i) 
		etacns = 0.157
c	etap  = (ZN1+Zcore)*0.5 *ZN2  *etacns
c	        etap  = (ZN1+ZN2)*0.5 *ZCORE*etacns
c 	eta = 0.5*etap/xk
		eta=(zn1+zcore)*zn2*rm/h2m/xk*197.32858/137./2.
		rmin = 0.1
	    write(165,*) xk,zn1,zn2,ZCore,etap,eta
	    call flush(165)
	  do ir=int(rmin/step2)+1,numr1
	    r = (ir-1)*step2
	    IE = 0
c    asym=exp(-xk*r)
            CALL WHIT(ETA,r,xk,-esep,Ly+1,CF,CG,IE)
 	    asym = CF(ly+1) * exp(-real(IE))
c	    asym = 1
!	    write(165,*) r,CF(ly+1),IE,asym
!	    call flush(165)
 	   write(63,*) real(r),real(chi1(i,ir)),real(chi1(i,ir)/asym),
     x     		asym,IE
	   write(164,*) real(r),real(chi1(i,ir)/asym)
	     if(ir.gt.2.and.ir.lt.numr1-1.and.real(chi1(i,ir)).ne.0) then
	      effpot=real(-chi1(i,ir-2)+16*chi1(i,ir-1)
     +	         -30*chi1(i,ir)+16*chi1(i,ir+1)-chi1(i,ir+2))
     /         /step2**2/12.d0-real(dfloat(ly*(ly+1))/r**2*chi1(i,ir))
	     write(175,*) r,effpot
	      if(r.gt.1.2*(a3+1.)**(1./3.)) then
	      vpc=zn1*(zcore+zn2)*1.44/r
	      else
	      rad =   1.2*(a3+1.)**(1./3.)
	      vpc=zn1*(zcore+zn2)*1.44*(3.-(r/rad)**2)/(2.*rad)
	      endif
	      effpot=effpot*h2m/rm-real(chi1(i,ir))*(abs(esep)+vpc)
	      effpot=effpot/real(chi1(i,ir))
	      write(174,*) r,effpot,vpc,effpot+vpc
	     endif
	  enddo
	  write(63,*) '&'
	  write(164,*) '&'
	  write(174,*) '&'
	  write(175,*) '&'
	enddo
500     continue
!	call flush(62)
	call flush(63)
	call flush(164)
	call flush(174)
	call flush(6)
	return
	end
      subroutine wf3_int(i,x,dro,nro,nch3max,chi3,chi3_int)
      implicit real *8 (a-h,o-z)
      dimension chi3(nch3max,nro)

      pin=x/dro
      in1=x/dro
      in2=in1+1
      in3=in2+1
c     print *,x,pin,in,in1
      ! linear interpolation
c     a=(wf2(in2,i)-wf2(in1,i))/dro
c     b=wf2(in1,i)-a*in1*dro
c     wf2_int=a*x+b
      ! quadratic interpolation
      x1=in1*dro
      x2=in2*dro
      x3=in3*dro

c     chi3_1=0
c     if(in1.ne.0) chi3_1=chi3(i,in1)
c     p=(x-x2)/dro
c     chi3_int=p*(p-1.d0)/2.d0*chi3_1+(1.d0-p**2)*chi3(i,in2)
c    &        +p*(p+1.d0)/2.d0*chi3(i,in3)
c                write(178,178) x,chi3(i,in1),chi3(i,in2)
c    &      ,chi3(i,in3),chi3_int
c    &      ,in1,in2,in3,a,b,c
c     return


      if(in1.ne.0) then
      a=(chi3(i,in1)+chi3(i,in3)-2*chi3(i,in2))/(2*dro**2)
c     b=(chi3(i,in2)-chi3(i,in1))/dro-a*(x1+x2)
      b=(-chi3(i,in1)*(x2+x3)+2*chi3(i,in2)*(x1+x3)
     ,   -chi3(i,in3)*(x1+x2))/(2*dro**2)
      c=chi3(i,in1)-a*x1**2-b*x1
      else
      a=(          0+chi3(i,in3)-2*chi3(i,in2))/(2*dro**2)
      b=(chi3(i,in2)-0          )/dro-a*(x1+x2)
      b=(                     2*chi3(i,in2)*(x1+x3)
     ,   -chi3(i,in3)*(x1+x2))/(2*dro**2)
      c=-a*x1**2-b*x1
      endif
      chi3_int=a*x**2+b*x+c
c     if(i.eq.4) write(178,178) x,chi3(i,in1),chi3(i,in2)
c                write(178,178) x,chi3(i,in1),chi3(i,in2)
c    &      ,chi3(i,in3),chi3_int
c    &      ,in1,in2,in3,a,b,c
178   format(f6.2,4d13.4,3i3,3d13.4)
      return
      end

